<%
'============================================================================================
' File name:        headhtml.asp
' Created:          30-Jan-2002
' Author:           D. Allen-Williams
' Description:      Main menu included in most main (secure) pages.
' Issues:           
'============================================================================================
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">    
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <meta name="Version"   content="2.0">
    <meta name="Author"    content="Common Services Agency (CSA)">
    <meta name="Copyright" content="CSA (ISD) 2000">

<%
	'Output stylesheet link, script links, title, meta pairs
    Call OutputHeadHTML() 
    
    'Close the head tag (some pages may want it kept open for event handler script blocks)
    If g_blnCloseHead Then
        Response.Write vbCrLf & "</head>" & vbCrLf
    End If


'============================================================================================
Sub OutputHeadHTML()
' Description:  Builds the HTML head section, using global g_strPageTitle, g_strStylesheet (etc) 
' Pass:         None
' Return:       The head section of the HTML page as a string.
' Raise Errors: None
'---------------------------------------------
' Date          Developer            Comments
' 18-Jan-2002   D. Allen-Williams    Created
'---------------------------------------------

    Dim strHead     'As String
    Dim arrItems    'As Array
    Dim i           'As Integer

'---------------------------------------------
    
    strHead = ""

    'Add the meta pairs
    If Len(g_strMetaPairs) > 0 Then
        arrItems = Split(g_strMetaPairs, ",")
        For i = LBound(arrItems) To UBound(arrItems) - 1 Step 2
            strHead = strHead & "    <meta name=""" & arrItems(i) & """ content=""" & arrItems(i+1) & """>" & vbNewLine
        Next
    End If
    
    strHead = strHead & vbNewLine
    
    'Add the page title
    If Len(g_strPageTitle) > 0 Then
        strHead = strHead & "    <title>" & g_strPageTitle & "</title>" & vbNewLine
    End If
    
    'Add a stylesheet
    If Len(g_strStylesheet) > 0 Then
        strHead = strHead & "    <link rel=""stylesheet"" href=""" & g_strStylesheet &  """>" & vbNewLine
    End If
        
    'Add client-side javascripts
    If Len(g_strJavaScripts) > 0 Then        
        g_strJavaScripts = Replace(g_strJavaScripts, ";", ",")    'allow for comma-separated list or semi-colons.
        arrItems = Split(g_strJavaScripts, ",")                    'split into separate items
        For i = LBound(arrItems) To UBound(arrItems)
            arrItems(i) = Trim(arrItems(i))
            If Len(arrItems(i)) > 0 Then
                strHead = strHead & "    <script language=""JavaScript"" src=""" & arrItems(i) & """></script>" & vbNewLine
            End If
        Next  
    End If
    
    'Add client-side VB scripts
    If Len(g_strVBScripts) > 0 Then
        g_strVBScripts = Replace(g_strVBScripts, ";", ",")    'allow for comma-separated list or semi-colons.
        arrItems = Split(g_strVBScripts, ",")                'split into separate items
        For i = LBound(arrItems) To UBound(arrItems)
            arrItems(i) = Trim(arrItems(i))
            If Len(arrItems(i)) > 0 Then
                strHead = strHead & "    <script language=""VBScript"" src=""" & arrItems(i) & """></script>" & vbNewLine
            End If
        Next
    End If
    
    'Add the target frame
    If Len(g_strTargetFrame) > 0 Then
        strHead = strHead & "    <base target=""" & g_strTargetFrame &  """>" & vbNewLine
    End If
    
    'Strip trailing CR-LF
    strHead = Left(strHead, Len(strHead) - 2)
    
    Response.Write strHead
        
End Sub
%>
