<%
Option Explicit
'============================================================================================
' File name:    verifyall.asp
' Description:  Runs a series of verification routines on several protocol XML definitions.
'============================================================================================
%>
<!--#include file="../includes/Common.asp"-->
<!--#include file="../includes/Config.asp"-->
<!--#include file="../includes/ConfigurationFiles.asp"-->
<!--#include file="../includes/Verify.asp"-->
<%
Response.Buffer = False
Dim m_configurationFiles
Set m_configurationFiles = New ConfigurationFiles
Set m_configurationFiles.MessageTypeConfig = g_messageTypesConfig.FindByMessageTypeId(CInt(Request.Form("msgtype")))
Set m_configurationFiles.TargetSchemaString = Request.Form("targetSchemaString")

Function ClientProtocolDir()    ClientProtocolDir   = Request.Form("clientProtocolDir") End Function
Function ServerProtocolDir()    ServerProtocolDir   = Request.Form("serverProtocolDir") End function
Function TitleString()          TitleString         = "Batch verification of protocol xml in folder " & ProtocolRootDirectory() End Function

Function ConfigurationId()
    Dim result
    Call GetFormValueDefault("Configuration", result, "long", "1")
    ConfigurationId = result
End Function

Function ProtocolRootDirectory()
    If ConfigurationId() = 1 Then
        ProtocolRootDirectory = ClientProtocolDir()
    ElseIf ConfigurationId() = 2 Then
        ProtocolRootDirectory = ServerProtocolDir()
    End If
End Function

Sub WriteResults()
    Dim arrFiles
    If (Len(ProtocolRootDirectory()) > 0) and (ProtocolRootDirectory() <> "add path to shared working directory here") Then
        Dim oFS
        Set oFS = CreateObject("Scripting.FileSystemObject")
        If ( Not oFS Is Nothing ) Then
            Dim oFolder
            Set oFolder = oFS.GetFolder(ProtocolRootDirectory())
            Redim arrFiles(2,0)
            Call GenerateFileTypeDirList(oFolder, ProtocolRootDirectory(), "xml", arrFiles, 0)
            Set oFolder = Nothing
        End If
        Set oFS = Nothing
    Else
        Response.Write "Must enter a path to the shared working directory."        
    End If	

    If IsArray(arrFiles) Then
        With Response
            Dim intCount
            For intCount = LBound(arrFiles, 2) to UBound(arrFiles, 2)
                m_configurationFiles.ProtocolXmlPath = arrFiles(0, intCount)
                Dim strFile
                Dim strFolder
                strFolder = Left(m_configurationFiles.ProtocolXmlPath, InStrRev(m_configurationFiles.ProtocolXmlPath, "\")-1)
                strFile = Right(m_configurationFiles.ProtocolXmlPath, Len(m_configurationFiles.ProtocolXmlPath) - InStrRev(m_configurationFiles.ProtocolXmlPath, "\"))
                .Write("<table class=""verifyAll"">")
                .Write "<tr><td class=""verifyAllColumn1"">" & strFolder & "</td>"
                If m_configurationFiles.ProtocolValidationXmlFilesLoadedOk(False) Then
                    Dim strOutHTML
                    Dim verifyProtXml
                    Set verifyProtXml = New VerifyProtocolXml
                    If verifyProtXml.ValidateXML(m_configurationFiles, False, True, strOutHTML) Then
                        .Write "<td class=""verifyAllColumn2"">" & strFile & "</td>" 
                        .Write "<td class=""verifyAllColumn3""><img src=""../graphics/valid.gif""/></td>"
                    Else
                        Dim strProtocolXmlPath
                        Dim strClientXml
                        strProtocolXmlPath = strFolder & "\" & strFile	
                        If ConfigurationId() = 2 Then
	                        strProtocolXmlPath = ServerProtocolDir() & Replace(LCase(strProtocolXmlPath), LCase(ServerProtocolDir()), "")
	                        strClientXml = Replace(strProtocolXmlPath, ServerProtocolDir(), ClientProtocolDir())
	                        strClientXml = Replace(strClientXml, "\", "\\")
                        Else
	                        strClientXml = strProtocolXmlPath
	                        strClientXml = Replace(strClientXml, "\", "\\")
                        End If
                        strProtocolXmlPath = Replace(strProtocolXmlPath, "\", "\\")
                        .Write "<td class=""verifyAllColumn2""><a href=""#"" onclick=""javascript:showValidation('" & strProtocolXmlPath & "','" & strClientXml & "');"" style=""cursor:hand"">" & strFile & "</a></td>" 
                        .Write "<td class=""verifyAllColumn3""><a onclick=""javascript:showValidation('" & strProtocolXmlPath & "','" & strClientXml & "');"" style=""cursor:hand""><img src=""../graphics/invalid.gif"" border=""0""/></a></td>"
                    End If					
                Else
                    Response.Write "Unable to load the protocol or a configuration file required for protocol verification."
                End If
                .Write("</tr></table>")
            Next
        End With
    End If
End Sub

Function GenerateFileTypeDirList(oFolder, sBasePath, strExtension, arrFiles, lngFileCount)  ' As String
    ' Append files of type strExtension
    Dim oFile           'As Scripting.File
    For Each oFile In oFolder.Files
        If LCase(Right(oFile.Name, 4)) = "." & LCase(strExtension) Then
            Redim Preserve arrFiles(2, lngFileCount)
            arrFiles(0, lngFileCount) = oFile.Path
            arrFiles(1, lngFileCount) = oFile.Name
            lngFileCount = lngFileCount + 1
        End If
    Next
    Set oFile = Nothing

    ' Append children folders
    Dim oSubFolder      ' As Scripting.Folder
    Dim sChildOut       ' As String
    For Each oSubFolder In oFolder.SubFolders
        sChildOut = GenerateFileTypeDirList(oSubFolder, sBasePath, strExtension, arrFiles, lngFileCount)
    Next
    Set oSubFolder = Nothing
        
    GenerateFileTypeDirList = ""
End Function
%>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <title><%= TitleString() %></title>
        <link rel="stylesheet" href="../stylesheets/pvtBuilder.css" type="text/css"/>
        <script language="javascript" type="text/javascript">
            function showValidation(strProtocolXmlPath, strClientXml)
            {
                if(document.readyState != 'complete')
                {
                    alert('Please wait until the page has been loaded.');
                    return (false);
                }
                var postForm = document.forms("frmValidateProtocol");
                postForm.children.namedItem("pvtServerProtocolPath").value = strProtocolXmlPath;
                postForm.children.namedItem("clientxml").value = strClientXml;
                window.open('about:blank', 'verifyDoc', 'menubar=no,toolbar=no,left=30,top=30, width=800,height=800', false);
                postForm.submit();
            }
        </script>
    </head>
    <body>
        <script language="javascript" type="text/javascript">
            document.body.style.cursor = "wait";
        </script>
        <h2><%= TitleString() %></h2>
        <table class="verifyAll">
            <tr>
                <td class="verifyAllHeader1">Path</td>
                <td class="verifyAllHeader2">File</td>
                <td class="verifyAllHeader3">Valid</td>
            </tr>
        </table>
        <%Call WriteResults()%>
        <form id="frmValidateProtocol" action="verify.asp" method="post" target="verifyDoc">
            <input type="hidden" id="clientProtocolDir" name="clientProtocolDir" value="<%= ClientProtocolDir()%>"/>
            <input type="hidden" id="serverProtocolDir" name="serverProtocolDir" value="<%= ServerProtocolDir()%>"/>
            <input type="hidden" id="Configuration" name="Configuration" value="<%= ConfigurationId()%> "/>
            <input type="hidden" id="msgtype" name="msgtype" value="<%= m_configurationFiles.MessageTypeConfig.Id %>"/>
            <input type="hidden" id="targetSchemaString" name="targetSchemaString" value="<%= m_configurationFiles.TargetSchemaString %>"/>
            <input type="hidden" id="pvtServerProtocolPath" name="pvtServerProtocolPath" value=""/>
            <input type="hidden" id="clientxml" name="clientxml" value=""/>
        </form>
    </body>
    <script language="VBScript" type="text/vbscript">
        document.body.scroll = "yes"
        window.name = "verifyAllWindow"
        document.body.style.cursor=""
    </script>
</html>

