' Global constant
Const DELETED_FLAG = "DELETED"
Const UNDELETE_FLAG = "UNDELETE"
Const DELETED_DYNA_FIELD_FLAG = "DELETEDDYNAFIELD"
Const XPATH_TRANSLATION = """ABCDEFGHIJKLMNOPQRSTUVWXYZ"", ""abcdefghijklmnopqrstuvwxyz"""

'Global variables
Dim strCurrentHCP
Dim m_blnShowDeletedDynaTableRows
Dim locationSelectedIndex
Dim specialtySelectedIndex
Dim hcpSelectedIndex

m_blnShowDeletedDynaTableRows = true


Sub Document_OnClick()
'
' Description:  Hides the date picker when any part of the document is clicked.
' Parameters:   None
' 
    If Not document.all("popcal") Is Nothing Then
        document.all("popcal").style.visibility = "hidden"
    End If
End Sub

Function AddRow(ByVal strFormElement)
'
' Description:  Adds a row to a dynaTable element.
' Parameters:   strFormElement - name of the dynaTable
' Returns:      The number of the row added
'
    Dim strCellText     'As String
    Dim intRow          'As Integer
    Dim objRow          'As Object
    Dim objCell         'As Object
    Dim objNewCell      'As Object
    Dim objElement      'As Object        
    Dim objOption       'As Object
    Dim objFirstFld     'As Object
    Dim blnFirstFld     'As Boolean
    Dim blnDeleted      'As Boolean
    Dim strElement      'As String
    Dim objTREl         
    
    'Check if we are copying a deleted/undeleted row in the table and use the correct element name
    If Not document.all(strFormElement & "_1") Is Nothing Then
        strElement = (strFormElement & "_1")
        blnDeleted = False
     Else If Not document.all(strFormElement & "_1DELETED") Is Nothing Then
         strElement = (strFormElement & "_1DELETED")
         blnDeleted = True
     End If
    End If

    blnFirstFld = False
    intRow = document.all(strFormElement).Rows.Length
    Set objRow = document.all(strFormElement).InsertRow()

    For Each objCell In document.all(strElement).cells
        strCellText = Replace(objCell.innerHTML, "_1", "_" & CStr(intRow))
        'Attempt a switch to remove the 'selected' tag on options
        strCellText = Replace(strCellText, "selected>", ">")

        'Create a new cell
        Set objNewCell = objRow.insertCell

        'Copy attributes of previous cell to new cell
        objNewCell.innerHTML = strCellText
            	
        objNewCell.mergeattributes objCell
        objNewCell.id = Replace(objCell.id, "_1", "_" & CStr(intRow))
    Next

    'Give the new row an ID
    ObjRow.id = strFormElement & "_" & intRow

    'Initialise the values of the cells	
    For Each objCell In objRow.cells
        For Each objElement In objCell.children
            If Not blnFirstFld Then
                Set objFirstFld = objElement
                blnFirstFld = True
            End If

            Select Case LCase(Left(objElement.tagName, 3))
                Case "tex"  'textArea
                    objElement.value = ""
                Case "sel"  'combo box
                    For Each objOption In objElement.options
                        objOption.selected = False  'Doesn't work??
                    Next
                Case "inp"	'input
                    Select Case LCase(objElement.type)
                        Case "hidden"   'Do nothing
                        Case "radio"    'Not supported for dynaTables
                        Case Else
                            objElement.value = ""
                    End Select
            End Select
        Next
    Next

    'Update the row count
    Call updateRowCount(strFormElement, 1)
    
    'renumber the rows to keep them in synch
    Set objTREl = document.all(strElement).parentElement.parentElement
    Call RenumberRows(objTREl,1,1)
    
    On Error Resume Next
    Call objFirstFld.focus()

    Set objCell = Nothing
    Set objRow = Nothing

    AddRow = intRow

End Function

Sub UpdateRowCount(strFormElement, intCount)
' Description:  updates row count field
' Parameters:   strFormElement - name of rowcount field for the dynaTable
'                intCount - number by which the rowcount is to be incremented (decremented if this is a minus number)

    Dim objRowCount
    Dim intRowCount

    'Get the rowcount object
    Set objRowCount = document.all(strFormElement & "_rowCount")

    If (Not objRowCount Is Nothing) And IsNumeric(intCount) Then
        intRowCount = objRowCount.value
        If IsNumeric(intRowCount) Then
            intRowCount = intRowCount + intCount
            objRowCount.value = intRowCount
        End If
    End If

    If Not objRowCount Is Nothing Then
        Set objRowCount = Nothing
    End If
End Sub

Sub ShowHideDeletedRows(ByVal strFormElement)
' Description:  Event handler for Show/hide deleted rows button
' Parameters:   strFormElement - name of the dynaTable

    Dim objRow
    Dim objShowHideButton
    
    Set objShowHideButton = document.all("showHideDeleted_" & strFormElement)
    
    m_blnShowDeletedDynaTableRows = false
    
    If objShowHideButton.innerText = "Show Deleted Rows" Then
        m_blnShowDeletedDynaTableRows = true
    Else
        m_blnShowDeletedDynaTableRows = false
    End If
        
    For Each objRow in document.all(strFormElement).Rows
        If Instr(objRow.id, UNDELETE_FLAG) > 0 Then
            If m_blnShowDeletedDynaTableRows = true Then
                objRow.style.display = "block"
                objShowHideButton.innerText = Replace(objShowHideButton.innerText, "Show ", "Hide ")
                objShowHideButton.title = "Click here to hide deleted rows"
            Else
                objRow.style.display = "none"
                objShowHideButton.innerText = Replace(objShowHideButton.innerText, "Hide ", "Show ")
                objShowHideButton.title = "Click here to show deleted rows"
            End If
        End If            
    Next
    
End Sub

Sub DeleteRow(objChildCell, strFormElement)
'
' Description:  Given a child <TD> element object as parameter, delete the parent row and renumber children.
' Parameters:   objChildCell - the child <TD> element (delete button) whose parent row you want to delete
'
    Dim objTableBodyEl      
    Dim objTREl         
    Dim objTableEl  
    Dim intNewId
    
    'objTREl now points to the <TR> containing the child cell <objChildCell>.            
    Set objTREl = objChildCell.parentElement
    If not objTREl is nothing Then
    
        If Instr(objTREl.id, UNDELETE_FLAG) > 0 Then
            UndeleteRow(objChildCell)
        Else
            'We now have to get the parent TABLE element
            Set objTableBodyEl = objTREl.parentElement
            
            If objTREl.id = (strFormElement & "_1") Then
                If Not document.all(strFormElement & "_1DELETED") Is Nothing Then
                    intNewId = (objTableBodyEl.Rows.Length+1)
                    objTREl.id = Replace(objTREl.id, "_1", "_" & intNewId)
                End If
            End If

            'If there is only one dynatable row ( the table header + 1 row)
            If objTableBodyEl.Rows.Length => 1 Then 
                'Mark the row for deletion
                objTREl.id = objTREl.id & DELETED_FLAG
                Call MarkFieldsAsDeleted(objTREl)
                Call RenumberRows(objTableBodyEl, 1,1)
                Call updateRowCount(objTableBodyEl.parentElement.id, -1)
                Call ShowDeletedRow(objTREl, strFormElement)
                
                Set objTableEl = objTableBodyEl.parentElement
                document.all("showHideDeleted_" & objTableEl.id).style.display = "block"
            End If
        
        End If
    End If
End Sub

Sub UndeleteRow(objChildCell)
' Description:  Undeletes a row previously deleted from a dynaTable.
' Parameters:   objChildCell - the child <TD> element (undelete button) whose parent row you want to undelete

    Dim objTableBodyEl      
    Dim objTREl         
    Dim objTableEl  
    Dim objTRdeleted
    Dim objCell
    Dim objRow
    Dim blnDeletedRowsExist

    'objTREl now points to the <TR> containing the child cell <objChildCell>.            
    Set objTREl = objChildCell.parentElement
    If not objTREl is nothing Then
        'We now have to get the parent TABLE element
        Set objTableBodyEl = objTREl.parentElement

        Set objTRdeleted = objTableBodyEl.Rows(objTREl.rowindex - 1)
        objTRdeleted.id = Replace(objTRdeleted.id, DELETED_FLAG, "")
        
        MarkFieldsAsUndeleted(objTREl)
        
        objTRdeleted.style.display = "block"
        
        Call RenumberRows(objTableBodyEl, 1,1)
        Call UpdateRowCount(objTableBodyEl.parentElement.id, 1)

        objTREl.RemoveNode(true) 'True means delete all child nodes (<TD>s)
    End If
    
    Set objTableEl = objTableBodyEl.parentElement

    blnDeletedRowsExist = false
    For Each objRow in objTableEl.Rows
        If Instr(objRow.id, DELETED_FLAG) <> 0 Then
            blnDeletedRowsExist = true
            Exit for
        End If
    Next
    
    If Not blnDeletedRowsExist Then
        document.all("showHideDeleted_" & objTableEl.id).style.display = "none"
    End If
End Sub

Sub ShowDeletedRow(objTREl, strFormElement)
' Description:  Shows a read-only row with struck-through text in a dynatable where a row has been deleted.
' Parameters:   objTREl - the deleted row - made invisible here but not removed

    Dim objTableEl
    Dim objNewRow
    Dim objNewCell
    Dim objChild
    Dim objDeleteCell
    Dim objDeleteButton
    Dim objUndeleteButton
    Dim i
    Dim j
    Dim objSubChild
    Dim clickEvent
    Dim objShowHideButton
    
        set objTableEl = objTREl.parentElement
        set objNewRow = objTableEl.InsertRow(objTREl.rowIndex+1)
        objNewRow.id = objTREl.id & UNDELETE_FLAG

        Set objDeleteCell = objTREl.Cells(0)
        Set objNewCell = objNewRow.insertCell()
        objNewCell.className = objDeleteCell.className
        objNewCell.style.backgroundColor = objDeleteCell.style.backgroundColor
        objNewCell.style.width = objDeleteCell.style.width
        objNewCell.style.height = objDeleteCell.style.height
        objNewCell.onMouseOver = objDeleteCell.onMouseOver
        objNewCell.onMouseOut = objDeleteCell.onMouseOut
        objNewCell.onClick = objDeleteCell.onClick
        objNewCell.title = "Click here to re-instate this deleted row"
        objNewCell.id = "un" & objDeleteCell.id
        
        Set objDeleteButton = objDeleteCell.ChildNodes(0)
        Set objUndeleteButton = document.CreateElement("IMG")

        objUndeleteButton.src = "../graphics/undo.png"
        objUndeleteButton.style.width = objDeleteButton.style.width
        objUndeleteButton.style.height = objDeleteButton.style.height
        objNewCell.appendChild(objUndeleteButton)
        
        For i= 1 to objTREl.Cells.Length-1
            Set objChild = objTREl.Cells(i)
            Set objNewCell = objNewRow.insertCell()
            objNewCell.innerText = ""
            objNewCell.colspan = objChild.colspan
            objNewCell.width = objChild.width
            
            For j = 0 to objChild.ChildNodes.Length - 1
                Set objSubChild = objChild.ChildNodes(j)
                If TypeName(objSubChild) = "HTMLInputElement" Then
                    If Trim(objSubChild.value) = "" Then
                        objNewCell.innerText = ""
                    Else
                        objNewCell.innerHtml = "<del>" & objSubChild.value & "<del>"
                        If IsDate(objSubChild.value) Then
                            objNewCell.align = "center"
                        End If
                    End If
                End If
            Next                  
        Next
        
        objTREl.style.display = "none"
        
        Set objShowHideButton = document.all("showHideDeleted_" & strFormElement)
        m_blnShowDeletedDynaTableRows = false
        If objShowHideButton.innerText = "Show Deleted Rows" Then
            m_blnShowDeletedDynaTableRows = false
        Else
            m_blnShowDeletedDynaTableRows = true
        End If

        If m_blnShowDeletedDynaTableRows Then
            objNewRow.style.display = "block"
        Else
            objNewRow.style.display = "none"
        End If
        
End Sub

Sub RenumberRows(objParentEl, startRow, renumberFrom)
'
' Description:  Incrementally renumber rows in a table, starting from zero based row <startRow>.
' Parameters:   objParentEl - identifies the table containing row(s) that you want to delete, note that
'               all <TR> elements  must have id property set to include DELETED_FLAG constant (or else they
'               won't be deleted, obviously)   
'               startRow - 0 based index of row to start 
'               renumberFrom - number to start renumbering rows from. Should be > 1  
'
    Dim strTable
    Dim intCount
    Dim objChildEl
    Dim strSuffix
    Dim intDelimiterPosition

    strTable = objParentEl.id
    
    'Now renumber the rows 
    For intCount = startRow to (objParentEl.Rows.Length-1)
        'Get the row object
        Set objChildEl = objParentEl.Rows(intCount)
        
        If Instr(objChildEl.id, DELETED_FLAG) = 0 Then 
            'If the row has not been marked to be deleted, reset its id
            
            intDelimiterPosition = InStrRev(objChildEl.id, "_")
            strSuffix = Right(objChildEl.id, Len(objChildEl.id)-intDelimiterPosition)
            objChildEl.id = Replace(objChildEl.id, "_" & strSuffix, "_" & renumberFrom)
            
            'Renumber the fields in the table row
            Call RenumberCells(objChildEl, renumberFrom)
            renumberFrom = renumberFrom + 1
        End If 
    Next
End Sub

Sub MarkFieldsAsDeleted(objRow)
' Description:  Marks fields in a deleted dynatable row as deleted so that we can detect and remove them server-side
' Parameters:   objRow - the deleted row - not removed but invisible.  Its fields are passed to the server with Request.Form

Dim objCell
Dim objSubChild
Dim strHtml

    For Each objCell in objRow.ChildNodes
        For Each objSubChild in objCell.ChildNodes
            If TypeName(objSubChild) = "HTMLInputElement" Then
                strHtml = objSubChild.outerHtml
                strHtml = Replace(strHtml, objSubChild.name, objSubChild.name & DELETED_DYNA_FIELD_FLAG)
                objSubChild.outerHtml = strHtml
            End If
        Next
    Next

End Sub

Sub MarkFieldsAsUndeleted(objRow)
' Description:  Removes deleted flag from dynatable row fields so that they are not removed server side
' Parameters:   objRow - the undeleted row now re-instated

Dim objCell
Dim objSubChild

    For Each objCell in objRow.Cells
        For Each objSubChild in objCell.ChildNodes
            If TypeName(objSubChild) = "HTMLInputElement" Then
                strHtml = objSubChild.outerHtml
                strHtml = Replace(strHtml, DELETED_DYNA_FIELD_FLAG, "")
                objSubChild.outerHtml = strHtml
            End If
        Next
    Next

End Sub

Function RenumberCells(objChildEl, intNewCount)
' Description:  Renumbers cells in rows in a dynatable when rows are renumbered due to delete/undelete actions
'               Also renumbers controls in the cells.
' Parameters:   objChildEl - row whose cells/controls are to be renumbered
'               intNewCount - number to include in id in place of the old number (new row number)

    Dim objRow
    Dim objChild
    Dim objSubChild
    Dim objTable
    Dim lngObject
    Dim lngCellID
    Dim intCount
    Dim strTable
    Dim strOnClick
    Dim strObjectID
    Dim strNewObject
    Dim strName
    Dim strOldName
    Dim strId
    Dim intPos
    Dim strHtml
    Dim strOrigName

    'This is required for the script to work as there is a problem with the HTMLDOM element
    On Error Resume Next

    Set objRow = objChildEl

    Set objTable = objRow.parentElement.parentElement
    strTable = objTable.id

    If Not objRow Is Nothing Then	
        For Each objChild In objRow.ChildNodes
            'If the cell has an id then change the suffix
            If objChild.id <> "" Then
                intCount = Right(objChild.id, Len(objChild.id) - InStrRev(objChild.id, "_"))
                strId = Replace(objChild.id, "_" & intCount, "_" & intNewCount)
                objChild.id = strId
            End If	
            For Each objSubChild In objChild.ChildNodes
                If InStr(LCase(objSubChild.name), LCase(strTable)) > 0 Then                		
                    Select Case TypeName(objSubChild)
                        Case "HTMLInputElement"
                            strHtml = objSubChild.outerHtml
                            'Get the old suffix number							
                            intCount = Right(objSubChild.name, Len(objSubChild.name) - InStrRev(objSubChild.name, "_"))
                            'Replace the old suffix with the new
                            strHtml = Replace(strHtml, "_" & intCount, "_" & intNewCount)
                            'Update the outerHtml
                            objSubChild.outerHtml = strHtml	
                        Case "HTMLImg"
                            'Change the name to the new row number
                            'remember that the calendar image element has 2 suffixes on the name attribute "_?" and "_img"
                            strName = objSubChild.name
                            strOrigName = objSubChild.name
                            intPos = InStrRev(strName, "_img")
                            strTempName = left(strName,intPos-1)
                            intCount = Right(strTempName, Len(strTempName) - InStrRev(strTempName, "_"))
                            strName = Replace(strName, "_" & intCount, "_" & intNewCount)

                            'Replace the old suffix with the new, remembering the two suffixed names
                            strHtml = objSubChild.outerHtml
                            strHtml = Replace(strHtml, strOrigName, strName)
                            strHtml = Replace(strHtml, Left(strOrigName, Len(strOrigName) - 4), Left(strName, Len(strName) - 4))

                            'Update the outerHtml
                            objSubChild.outerHtml = strHtml                            
                    End Select
                End If
            Next
        Next
    End If		
End Function

Sub GoTab(ByVal intTabIndex)
'
' Description:  Performs visual effects when selecting a form tab.
' Parameters:   intTabIndex  - the number of the tab selected
'
    Dim strTab          'As String
    Dim strAnc          'As String
    Dim strCurrentTab   'As String
    Dim strNewTab       'As String
    Dim strSelected     'As String
    Dim intPrevTab      'As Integer
    Dim intPos          'As Integer

    strNewTab = "divTabControl_" & intTabIndex
    strCurrentTab = document.all("TabIndexStore").value

    'Change appearance of previous tab
    intPos = instr(strCurrentTab, "_")
    intPrevTab = right(strCurrentTab, len(strCurrentTab) - intPos)

    If CStr(intPrevTab) <> CStr(intTabIndex) Then
        'Change appearance of selected tab
        strSelected = "tab_" & CStr(intTabIndex) 
        document.all(strSelected).style.backgroundColor = "#000066"
        document.all(strSelected).style.color = "white"

        'Change appearance of old tab
        strSelected = "tab_" & CStr(intPrevTab) 
        document.all(strSelected).style.backgroundColor = "white"
        document.all(strSelected).style.color = "black"

        document.all(strCurrentTab).style.visibility = "hidden"
        document.all(strNewTab).style.visibility = "visible"
        document.all("TabIndexStore").value = "divTabControl_" & intTabIndex
    End If

End Sub

Sub HelpText(strHelpText, strTitle)
'
' Description:  Display a pop up message box containing help desk.
' Parameters:   strHelpText - the text to display
'               strTitle - the title to use for the window
'
    If ( Trim(strHelpText) <> "" ) Then
        strHelpText = Replace(strHelpText, "#NEWLINE_", Chr(10))
        Call MsgBox(strHelpText, "64", strTitle)
    End If
End Sub	

Function setFieldValuesFromControl(strControlType, strHCPField, blnInitialise)
    Dim objControlXML, objHCP, objHCPXML, objAttribute, objProtXML, objPerson
    Dim objOrganisationType, objOrganisation, objOrganisationNode, objRadioGroup
    Dim objRadio
    Dim strHCPId, strXML, strFieldGroupPrefix, strOrganisationTypeName
    Dim strOrganisationHceId

    Set objControlXML = document.all("xml" & strControlType)

    Set objHCP = document.all("cmb" & strControlType & strHCPField)

    If Not objHCP Is Nothing Then
        strHCPId = objHCP.value

        If (Len(strHCPId) > 0) And (strHCPId <> "-1") Then
            strCurrentHCP = objHCP.value
            'Get the control dom to retrieve the information		
            If Not objControlXML Is Nothing Then
                Set objHCPXML = objControlXML.selectSingleNode("//hce[@hceid='" & strHCPId & "']")
                If Not objHCPXML Is Nothing Then
                    'Get the field identifier prefix by selecting the hces node with the attribute abstracttype set to 'person'
                    Set objPerson = objControlXML.selectSingleNode("//hces[@abstracttype='person']")
                    If Not objPerson Is Nothing Then
                        strFieldGroupPrefix = objPerson.getAttribute("fieldidentifier") & ""

                        If Len(Trim(strFieldGroupPrefix)) > 0 Then
                            For Each objAttribute in objHCPXML.Attributes
                                If LCase(objAttribute.nodeName) <> "hceid" And _
                                        LCase(objAttribute.nodeName) <> "hcename" And _
                                        LCase(objAttribute.nodeName) <> "type" And _
                                        LCase(objAttribute.nodeName) <> "isdefault" Then
                                    If(Not document.all(strFieldGroupPrefix & "_" & objAttribute.nodeName) Is Nothing) Then
                                        document.all(strFieldGroupPrefix & "_" & objAttribute.nodeName).value = objAttribute.nodevalue
                                        document.all(strFieldGroupPrefix & "_" & objAttribute.nodeName).readOnly = true
                                    End If
                                End If
                            Next
                        End If
                    End If

                    'Get the field identifier prefix by selecting the hces node with the attribute abstracttype set to 'organisation'
                    Set objOrganisationType = objControlXML.selectSingleNode("//hces[@abstracttype='organisation']")
                    If Not objOrganisationType Is Nothing Then
                        strFieldGroupPrefix = objOrganisationType.getAttribute("fieldidentifier") & ""
                        strOrganisationTypeName = "cmb" & strControlType & objOrganisationType.getAttribute("hcetypename") & ""

                        Set objOrganisation = document.all(strOrganisationTypeName)

                        If Not objOrganisation Is Nothing Then
                            strOrganisationHceId = objOrganisation.value 

                            If Len(Trim(strOrganisationHceId)) > 0 Then 
                                Set objOrganisationNode = objControlXML.selectSingleNode("//hce[@hceid='" & strOrganisationHceId & "']")

                                If Not objOrganisationNode Is Nothing Then
                                    If Len(Trim(strFieldGroupPrefix)) > 0 Then
                                        For Each objAttribute in objOrganisationNode.Attributes
                                            If	LCase(objAttribute.nodeName) <> "hceid" And _
                                                LCase(objAttribute.nodeName) <> "hcename" And _
                                                LCase(objAttribute.nodeName) <> "isdefault" And _
                                                LCase(objAttribute.nodeName) <> "type" And _
                                                (Not document.all(strFieldGroupPrefix & "_" & objAttribute.nodeName) Is Nothing) Then
                                                    document.all(strFieldGroupPrefix & "_" & objAttribute.nodeName).value = objAttribute.nodevalue
                                                    document.all(strFieldGroupPrefix & "_" & objAttribute.nodeName).readOnly = true
                                            End If
                                        Next
                                    End If
                                End If
                            End If
                        End If
                    End If
                Else
                    MsgBox "The selection have made cannot populate the fields because the referrer control data is unavailable."	
                End If
            Else
                MsgBox "The selection have made cannot populate the fields because the referrer control data is unavailable."	
            End If
        ElseIf strHCPId = "-1" And Not blnInitialise Then
            If MsgBox("Would you like to clear all GP / Consultant fields?", vbYesNo) = vbYes Then
                strXML = document.all("protocolXML").xml

                If Len(strXML) > 0 Then
                    Set objProtXML = CreateObject("MSXML2.DOMDocument")

                    objProtXML.setProperty "SelectionLanguage", "XPath"

                    If objProtXML.loadXML(strXML) Then
                        If Len(objProtXML.xml) > 0 Then
                            call ClearGpFields(objControlXML, objProtXML, "person")		
                            'call clearFields(objControlXML, objProtXML, "organisation")
                        End If
                    Else
                        msgbox "Could not load xml. Error=" & objProtXML.parseError.Reason
                    End If
                End If
            Else
                'Set selection back to the current hcp 
                objHCP.value = strCurrentHCP
            End If
        End If
    End If
End Function

Function clearFields(objControlXML, objProtXML, strAbstractType)
    Dim objAbstractType, objNodes, objNode, objRadioGroup, objRadio
    Dim strFieldGroupPrefix, strXPath

    Set objAbstractType = objControlXML.selectSingleNode("//hces[@abstracttype='" & strAbstractType & "']")
    If Not objAbstractType Is Nothing Then
        strFieldGroupPrefix = LCase(objAbstractType.getAttribute("fieldidentifier") & "")

        strXPath = "//question[starts-with(translate(@id,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz'),'" & strFieldGroupPrefix & "')]"

        On Error Resume Next			
        Set objNodes = objProtXML.selectNodes(strXPath)
        If Not objNodes Is Nothing Then
            For Each objNode in objNodes
                document.all(objNode.getAttribute("id")).value = ""
                document.all(objNode.getAttribute("id")).readOnly = false
            Next
        End If
        On Error Goto 0
    End If
End Function


Function ClearAllHcpFields(strAbstractType, objControlXML, objProtXml)

	Set objAbstractType = objControlXML.selectSingleNode("//hces[@abstracttype='" & strAbstractType & "']")
		
				If Not objAbstractType Is Nothing Then
					strFieldGroupPrefix = LCase(objAbstractType.getAttribute("fieldidentifier") & "")
					strXPath = "//question[starts-with(translate(@id,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz'),'" & strFieldGroupPrefix & "')]"

                On Error Resume Next			
                Set objNodes = objProtXML.selectNodes(strXPath)
                If Not objNodes Is Nothing Then
                    For Each objNode in objNodes
                        call clearFields(objControlXML, objProtXML, "person")		
                        call clearFields(objControlXML, objProtXML, "organisation")
                    Next
                End If
            End If
End Function


Function ClearGpFields(objControlXML, objProtXml, strAbstractType)

	Dim blnPracticeQuestion, blnRefOrqQuestion

	Set objAbstractType = objControlXML.selectSingleNode("//hces[@abstracttype='" & strAbstractType & "']")
		
	If Not objAbstractType Is Nothing Then
		strFieldGroupPrefix = LCase(objAbstractType.getAttribute("fieldidentifier") & "")
		'strFieldGroupPrefix = "refgp"
		strXPath = "//question[starts-with(translate(@id,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz'),'" & strFieldGroupPrefix & "')]"

		On Error Resume Next			
		Set objNodes = objProtXML.selectNodes(strXPath)
		If Not objNodes Is Nothing Then
			For Each objNode in objNodes
				blnPracticeQuestion = Instr(1, objNode.getAttribute("id"), "practice")
				blnRefOrgQuestion = Instr(1, objNode.getAttribute("id"), "reforg")
				If (blnPracticeQuestion = 0)and(blnRefOrgQuestion = 0) Then
					document.all(objNode.getAttribute("id") & "").value = ""
					document.all(objNode.getAttribute("id") & "").readOnly = false
				End If
			Next
		End If
	End If
End Function

Function clearTopLevelDetailsFields(strControlType, strHCPField, blnInitialise)
    
    Dim objHCP,objControlXML,objProtXML
    Dim objAbstractType, strFieldGroupPrefix, strXPath, objNodes
    Dim strValue, strCompare, intComparisonResult, strXML
    Dim strHCPId, objList, blnRegistrar, blnReferrer
    
    strXML = document.all("protocolXML").xml
    Set objHCP = document.all("cmb" & strControlType & strHCPField)
    
    strHCPId = objHCP.value
    
    If strHCPId = "-1" Then
        If MsgBox("Would you like to clear all fields?", vbYesNo) = vbYes Then
            
            Set objControlXML = document.all("xml" & strControlType)
    
            Set objProtXML = CreateObject("MSXML2.DOMDocument")
    
            objProtXML.loadXML(strXML)
            
            'Determine whether HCP or Referrer control.
            objProtXML.setProperty "SelectionLanguage", "XPath"
            strAbstractType = "organisation"
            call ClearAllHcpFields(strAbstractType, objControlXML, objProtXML)
            strAbstractType = "person"
            call ClearAllHcpFields(strAbstractType, objControlXML, objProtXML)
            
            'Get all control select elements and set selected values to -1.
            Set objNodeList = document.getElementsByTagName("select")
            For Each objNode in objNodeList
                'blnRegistrar = Instr(1, objNode.name, "registrar")
                blnReferrer = Instr(1, objNode.name, "referrer")
                If (blnReferrer > 0) Then
                    objNode.Options.selectedIndex = -1
                End If 
            Next
        End If    
    Else
        call setFieldValuesFromControl(strControlType, strHCPField, true)
    End If 
    objHCP.value = strHCPId      
End Function

Function matchGmcCode()
    Dim objGmcCode, objGmcCodeButton
    Dim strGmcNumber, strGmcCodeObject

    Set objGmcCodeButton = window.event.srcElement

    strGmcCodeObject = Mid(objGmcCodeButton.name, 5)

    msgbox strGmcCodeObject
    'Set objGmcCode = document.all()

    If Not objGmcCode Is Nothing Then
        strGmcNumber = objGmcCode.value
        msgbox strGmcNumber
        If Len(strGmcNumber) > 0 Then
            msgbox strGmcNumber
        Else
            MsgBox "Please provide a gmc number."
            call objGmcCode.focus()
        End If
    End If
End Function

Function loadHCEs(strXMLDOM, strChildHCEObject)
    Dim objHCEObject, objChildHCEObject, objXMLDOM, objSelectedHCEChildren, objOption, objSelectedHCEChild
    Dim intCount
    Dim strSelectedHCE, strXPath, strName

    'Get the current drop down list
    Set objHCEObject = window.event.srcElement

    'Get the child drop down list
    Set objChildHCEObject = document.all(strChildHCEObject)

    'Get the selected item from the current drop down list
    strSelectedHCE = objHCEObject.Value

    'Get the control data island
    Set objXMLDOM = document.all(strXMLDOM)
    		
    If (Not objChildHCEObject Is Nothing) And (Not objXMLDOM Is Nothing) Then			
        'Empty the dropdown below
        For intCount=objChildHCEObject.options.length to 1 Step -1
            objChildHCEObject.options.remove(intCount)		
        Next 

        If strSelectedHCE > 0 Then
            'Populate the drop down below with the children hces of the selected hce
            strXPath = "//hce[@hceid='" & strSelectedHCE & "']/hces/hce"
            Set objSelectedHCEChildren = objXMLDOM.selectNodes(strXPath)
            If Not objSelectedHCEChildren Is Nothing Then
                For Each objSelectedHCEChild in objSelectedHCEChildren
                    Set objOption = document.createElement("OPTION")
                    If Not objOption Is Nothing Then
                        If Not objChildHCEObject.appendChild(objOption) Is Nothing Then
                            objOption.value = objSelectedHCEChild.getAttribute("hceid") & ""

                            strName = objSelectedHCEChild.getAttribute("forename") & " " & objSelectedHCEChild.getAttribute("surname") & ""
                            If ((objSelectedHCEChild.getAttribute("type") & "") <> "") Then
                                strName = strName & " (" & objSelectedHCEChild.getAttribute("type") & ")"
                            End If

                            objOption.text = strName
                        End If
                   End If
                Next 
            Else
                MsgBox "An error occurred selecting the consultants for this specialty."
            End If
        Else
            MsgBox "There is no hce selected."
        End If
    Else
        MsgBox "An error has occurred with the Referrer control. Please contact SCI Support."		
        Exit Function
    End If
End Function

'Fires when the location dropdown is changed on the referrer or registrar control
'if they were created from user maintaned data  (TT53367)
Function locationChanged(controlType)

    Dim locationDropdown

    'Grab the location dropdown
    Set locationDropdown = document.all("cmb" & controlType & "Location")
    
    locationSelectedValue = locationDropdown.value
    
    If locationSelectedValue = "-1" Then
        'Clear All fields
        If MsgBox("Would you like to clear all fields?", vbYesNo) = vbYes Then
            Call clearSenderFields("Location", controlType)
        Else
            'Reset to previously selected index
            locationDropdown.selectedIndex = locationSelectedIndex
        End If
    Else
        'Populate Hcp Fields
        locationSelected(controlType)
    End If
    
End Function

'Fires when the specialty dropdown is changed on the referrer or registrar control
'if they were created from user maintaned data  (TT53367)
Function specialtyChanged(controlType)
    Dim specialtyDropdown
    Dim specialtySelectedValue
    
    'Grab dropdowns
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    
    specialtySelectedValue = specialtyDropdown.value
    
    If specialtySelectedValue = "-1" Then
        'Clear All Hcp fields
        If MsgBox("Would you like to clear the HCP fields?", vbYesNo) = vbYes Then
            Call clearSenderFields("Specialty", controlType)
        Else
            'Reset to previously selected index
            specialtyDropdown.selectedIndex = specialtySelectedIndex
        End If
    Else
        'Populate Hcp dropdown
        specialtySelected(controlType)
    End If
    
End Function

'Fires when the hcp dropdown is changed on the referrer or registrar control
'if they were created from user maintaned data  (TT53367)
Function hcpChanged(controlType)
    Dim hcpDropdown
    Dim hcpSelectedValue
    
    'Grab dropdowns
    Set hcpDropdown = document.all("cmb" & controlType & "Hcp")
    
    hcpSelectedValue = hcpDropdown.value
    
    If hcpSelectedValue = "-1" Then
        'Clear All Hcp fields
        If MsgBox("Would you like to clear the HCP fields?", vbYesNo) = vbYes Then
            Call clearSenderFields("Hcp", controlType)
        Else
            'Reset to previously selected index
            hcpDropdown.selectedIndex = hcpSelectedIndex
        End If
    Else
        'Populate Hcp Fields
        hcpSelected(controlType)
    End If
End Function

'Populates relevant dropdowns and fields when a location is selected
'from the user maintained data generated referrer control
Function locationSelected(controlType)

    Dim specialtyDropdown
    Dim locationDropdown
    
    'Clear the hcp fields if they are populated
    clearHcpFields()
    
    'Grab dropdowns
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    Set locationDropdown = document.all("cmb" & controlType & "Location")
    
    'Change the text of the first dropdown item for the location
    locationDropdown(0).text = "-- Clear All --"
    'Populate either specialty and hcp dropdown
    If Not (specialtyDropdown Is Nothing) Then
        populateSpecialtyDropdown(controlType)
        'There may be hcps present at the root location level. Add these to the hcp dropdown
        populateHcpDropdown(controlType)
    Else
        populateHcpDropdown(controlType)
    End If
    
    populateOrganisationFields(controlType)
    
    locationSelectedIndex = locationDropdown.selectedIndex
End Function

'Populates the hcp dropdown when a specialty is selected
'from the user maintained data generated referrer control
Function specialtySelected(controlType)
    Dim specialtyDropdown
    
    'Grab dropdown
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    
    'Change the text of the first dropdown item for the specialty
    specialtyDropdown(0).text = "-- Clear Specialty --"
    
    populateHcpDropdown(controlType)
    specialtySelectedIndex = specialtyDropdown.selectedIndex
End Function

'Populates relevant fields when a hcp is selected
'from the user maintained data generated referrer control
Function hcpSelected(controlType)
    Dim hcpDropdown
    
    'Grab dropdown
    Set hcpDropdown = document.all("cmb" & controlType & "Hcp")
    
    'Change the text of the first dropdown item for the hcp
    hcpDropdown(0).text = "-- Clear Hcp --"
    
    populateHcpFields(controlType)
    hcpSelectedIndex = hcpDropdown.selectedIndex
End Function

'Populates the specialty dropdown based in the sender details xml
'and the location selected
Function populateSpecialtyDropdown(controlType)
    Dim specialtyDropdown
    Dim locationDropdown
    Dim senderDetailsXml
    Dim locationXPath
    Dim locationNode
    Dim specialtyNodes
    Dim specialtyNode
    
    'Grab dropdowns
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    Set locationDropdown = document.all("cmb" & controlType & "Location")
    
    'Empty the dropdown
    Call clearDropdown(specialtyDropdown)
    
    'Set the first item in the dropdown
    Call addItemToDropdown(specialtyDropdown, "-- Please Select --", "-1", True)
    
    locationName = locationDropdown(locationDropdown.selectedIndex).text
    
    'Load the sender details xml
    Set senderDetailsXml = getSenderDetails(controlType)
    
    locationXPath = generateLocationXPath(locationName)
    
    Set locationNode = senderDetailsXml.selectSingleNode(locationXPath)
    Set specialtyNodes = locationNode.selectNodes("Specialty")
        
    For Each specialtyNode In specialtyNodes
        Call addItemToDropdown( specialtyDropdown, _
                                specialtyNode.selectSingleNode("SpecialtyName").text, _
                                specialtyNode.selectSingleNode("SpecialtyCode").text, _
                                False)
    Next
    
    specialtySelectedIndex = specialtyDropdown.selectedIndex
End Function

'Populates the specialty dropdown based in the sender details xml
'and the location or specialty selected
Function populateHcpDropdown(controlType)
    Dim hcpDropdown
    Dim specialtyDropdown
    Dim locationDropdown
    Dim locationName
    Dim locationXPath
    Dim senderDetailsXml
    Dim locationNode
    Dim locationNodes
    Dim hcpNode
    Dim hcpNodes
    Dim hcpXPath
    
    'Grab dropdowns
    Set hcpDropdown = document.all("cmb" & controlType & "Hcp")
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    Set locationDropdown = document.all("cmb" & controlType & "Location")
    
     'Empty the dropdown
    Call clearDropdown(hcpDropdown)
    
    locationName = locationDropdown(locationDropdown.selectedIndex).text
    
    'Load the sender details xml
    Set senderDetailsXml = getSenderDetails(controlType)
    
    locationXPath = generateLocationXPath(locationName)
    Set locationNode = senderDetailsXml.selectSingleNode(locationXPath)
    
    If (specialtyDropdown Is Nothing) Then
        hcpXPath = "HCP"
        Set hcpNodes = locationNode.selectNodes(hcpXPath)
    ElseIf (specialtyDropdown.value = "-1") Then
        hcpXPath = "HCP"
        Set hcpNodes = locationNode.selectNodes(hcpXPath)
    Else
        'Get the HCP nodes that exist under the selected Specialty
        hcpXPath = generateSpecialtyXPath(specialtyDropdown.value) & "/HCP"
        Set hcpNodes = locationNode.selectNodes(hcpXpath)
    End If
    Call addItemsToHcpDropDown(hcpDropdown, hcpNodes)
    hcpSelectedIndex = hcpDropdown.selectedIndex
End Function

'Populates the organisation fields relevant to the selected location 
Function populateOrganisationFields(controlType)
    Dim locationDropdown
    Dim locationCode
    Dim locationName
    Dim locationAddress
    Dim LocationPostcode
    Dim locationTelephone
    Dim senderDetailsXml
    Dim locationXpath
    Dim locationNode
    
    Set locationDropdown = document.all("cmb" & controlType & "Location")
    
    Set senderDetailsXml = getSenderDetails(controlType)
    
    locationName = locationDropdown(locationDropdown.selectedIndex).text
    locationXpath = generateLocationXPath(locationName)
    Set locationNode = senderDetailsXml.selectSingleNode(locationXpath)
    
    locationCode = locationNode.selectsinglenode("LocationNationalCode").text
	LocationPostcode = locationNode.selectsinglenode("LocationPostcode").text
	locationTelephone = locationNode.selectsinglenode("LocationTelephone").text
	locationAddress =   locationNode.selectsinglenode(".//AddressLine1").text & vbNewLine & _
		                locationNode.selectsinglenode(".//AddressLine2").text & vbNewLine & _
		                locationNode.selectsinglenode(".//AddressLine3").text & vbNewLine & _
		                locationNode.selectsinglenode(".//AddressLine4").text

    If Not (document.all("reforg_name") Is Nothing) Then
        document.all("reforg_name").value = locationName
        document.all("reforg_name").readOnly = true
    End If
    If Not (document.all("reforg_location_code") Is Nothing) Then
        document.all("reforg_location_code").value = locationCode
        document.all("reforg_location_code").readOnly = true
    End If
    If Not (document.all("reforg_address") Is Nothing) Then
        document.all("reforg_address").value = locationAddress
        document.all("reforg_address").readOnly = true
    End If
    If Not (document.all("reforg_postcode") Is Nothing) Then
        document.all("reforg_postcode").value = LocationPostcode
        document.all("reforg_postcode").readOnly = true
    End If
    If Not (document.all("reforg_phone") Is Nothing) Then
        document.all("reforg_phone").value = locationTelephone
    End If
    
End Function

'Populates the hcp fields relevant to the selected location or specialty
Function populateHcpFields(controlType)
	Dim hcpDropdown
    Dim specialtyDropdown
    Dim locationDropdown
	Dim locationXPath
	Dim hcpXPath
	Dim hcpNode
	Dim hcpIdentifier
	Dim hcpForename
	Dim hcpSurname
	Dim hcpCode
	Dim hcpCodeScheme
	Dim hcpPosition
	
	'Grab dropdowns
    Set hcpDropdown = document.all("cmb" & controlType & "Hcp")
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    Set locationDropdown = document.all("cmb" & controlType & "Location")
	
	locationName = locationDropdown(locationDropdown.selectedIndex).text
	
	hcpIdentifier = Split(hcpDropdown.value, "~")
    
    'Load the sender details xml
    Set senderDetailsXml = getSenderDetails(controlType)
    
    locationXPath = generateLocationXPath(locationName)
    	
    If (specialtyDropdown Is Nothing) Then
        hcpXPath = locationXPath & "/" & generateHcpXPath(hcpIdentifier(0), hcpIdentifier(1))
	ElseIf (specialtyDropdown.value = "-1") Then
	    hcpXPath = locationXPath & "/" & generateHcpXPath(hcpIdentifier(0), hcpIdentifier(1))
	Else
	    hcpXPath = locationXPath & "/" & generateSpecialtyXPath(specialtyDropdown.value) & "/" & generateHcpXPath(hcpIdentifier(0), hcpIdentifier(1))
	End If
	
	Set hcpNode = senderDetailsXml.selectSingleNode(hcpXPath)
	
	hcpForename = hcpNode.selectSingleNode("HCPForename").text
	hcpSurname = hcpNode.selectSingleNode("HCPSurname").text
	hcpCode = hcpNode.selectSingleNode("HCPCode").text
	hcpCodeScheme = hcpNode.selectSingleNode("HCPCodeScheme").text
	hcpPosition = hcpNode.selectSingleNode("HCPPosition").text
	
	If Not (document.all("refhcp_forename") Is Nothing) Then
        document.all("refhcp_forename").value = hcpForename
        document.all("refhcp_forename").readOnly = true
    End If
    If Not (document.all("refhcp_surname") Is Nothing) Then
        document.all("refhcp_surname").value = hcpSurname
        document.all("refhcp_surname").readOnly = true
    End If
    If Not (document.all("refhcp_scheme") Is Nothing) Then
        document.all("refhcp_scheme").value = hcpCodeScheme
        document.all("refhcp_scheme").readOnly = true
    End If
    If Not (document.all("refhcp_gmc_code") Is Nothing) Then
        document.all("refhcp_gmc_code").value = hcpCode
        document.all("refhcp_gmc_code").readOnly = true
    End If
    If Not (document.all("refhcp_position") Is Nothing) Then
        document.all("refhcp_position").value = hcpPosition
    End If
	
End Function

Function generateLocationXPath(locationName)
    locationName = Trim(locationName)
    generateLocationXPath = "//Location[LocationName[translate(text(), " & XPATH_TRANSLATION _ 
                                & ") = translate(" & dQ(locationName) & ", " & XPATH_TRANSLATION & ")]]"
End Function

Function generateSpecialtyXPath(specialtyCode)
    specialtyCode = Trim(specialtyCode)
    generateSpecialtyXPath = "Specialty[SpecialtyCode[translate(text(), " & XPATH_TRANSLATION & ") = translate(" & dQ(specialtyCode) & ", " & XPATH_TRANSLATION & ")]]"
End Function

Function generateHcpXPath(hcpCode, hcpCodeScheme)
    hcpCode = Trim(hcpCode)
    hcpCodeScheme = Trim(hcpCodeScheme)
    generateHcpXPath = "HCP[HCPCode[translate(text(), " & XPATH_TRANSLATION & ") = translate(" _ 
                        & dQ(hcpCode) & ", " & XPATH_TRANSLATION & ")] and HCPCodeScheme[translate(text(), " _
                        & XPATH_TRANSLATION & ") = translate(" & dQ(hcpCodeScheme) & ", " & XPATH_TRANSLATION & ")]]"
End Function

'Clears input fields based on the field type passed
Function clearSenderFields(fieldsType, controlType)
    Dim specialtyDropdown
    Dim locationDropdown
    Dim hcpDropdown
    
    'Grab dropdowns
    Set specialtyDropdown = document.all("cmb" & controlType & "Specialty")
    Set locationDropdown = document.all("cmb" & controlType & "Location")
    Set hcpDropdown = document.all("cmb" & controlType & "Hcp")
    
    Select Case fieldsType
        Case "Location"
            locationDropdown(0).text = "-- Please Select --"
            clearOrganisationFields()
            clearHcpFields()
            clearDropdown(hcpDropdown)
            If Not(specialtyDropdown Is Nothing) Then
                clearDropdown(specialtyDropdown)
            End If
        Case "Specialty"
            clearHcpFields()
            locationSelected(controlType)
            
        Case "Hcp"
            clearHcpFields()
            If (specialtyDropdown Is Nothing) Then
                locationSelected(controlType)
            ElseIf (specialtyDropdown.value = "-1") Then
                locationSelected(controlType)
            Else
                specialtySelected(controlType)
            End If 
        
    End Select
End Function


Function clearHcpFields()

    If Not (document.all("refhcp_forename") Is Nothing) Then
        document.all("refhcp_forename").value = ""
        document.all("refhcp_forename").readOnly = false
    End If
    If Not (document.all("refhcp_surname") Is Nothing) Then
        document.all("refhcp_surname").value = ""
        document.all("refhcp_surname").readOnly = false
    End If
    If Not (document.all("refhcp_scheme") Is Nothing) Then
        document.all("refhcp_scheme").value = ""
        document.all("refhcp_scheme").readOnly = false
    End If
    If Not (document.all("refhcp_gmc_code") Is Nothing) Then
        document.all("refhcp_gmc_code").value = ""
        document.all("refhcp_gmc_code").readOnly = false
    End If
    If Not (document.all("refhcp_position") Is Nothing) Then
        document.all("refhcp_position").value = ""
        document.all("refhcp_position").readOnly = false
    End If

End Function

Function clearOrganisationFields()

    If Not (document.all("reforg_name") Is Nothing) Then
        document.all("reforg_name").value = ""
        document.all("reforg_name").readOnly = false
    End If
    If Not (document.all("reforg_location_code") Is Nothing) Then
        document.all("reforg_location_code").value = ""
        document.all("reforg_location_code").readOnly = false
    End If
    If Not (document.all("reforg_address") Is Nothing) Then
        document.all("reforg_address").value = ""
        document.all("reforg_address").readOnly = false
    End If
    If Not (document.all("reforg_postcode") Is Nothing) Then
        document.all("reforg_postcode").value = ""
        document.all("reforg_postcode").readOnly = false
    End If
    If Not (document.all("reforg_phone") Is Nothing) Then
        document.all("reforg_phone").value = ""
        document.all("reforg_postcode").readOnly = false
    End If
    
End Function

'Clears a dropdown list
Function clearDropdown(dropdown)
    dropdown.length = 0
End Function

Function addItemsToHcpDropDown(hcpDropdown, hcpNodes)
    Dim hcpNode
    
    If hcpNodes.length > 0 Then
        Call addItemToDropDown(hcpDropdown, "-- Please Select --", "-1", True)
        For Each hcpNode In hcpNodes
            Call addItemToDropdown( hcpDropdown, _
                                    hcpNode.selectSingleNode("HCPForename").text & " " & _
                                    hcpNode.selectSingleNode("HCPSurname").text, _
                                    hcpNode.selectSingleNode("HCPCode").text & "~" & _
                                    hcpNode.selectSingleNode("HCPCodeScheme").text, _
                                    False)
        Next
    End If
End Function

'Adds an item to a dropdown list
Function addItemToDropdown(dropdown, text, value, selected)
    
    Dim optionElement

    Set optionElement = document.createElement("OPTION")
    optionElement.text = text
    optionElement.value = value
    optionElement.selected = selected
    dropdown.add optionElement
    Set optionElement = Nothing
    
End Function

'Returns the sender details xml as an MSXML2.DOMDocument
Function getSenderDetails(controlType)
    Dim senderDetailsXmlDataIsland
    
    Set senderDetailsXmlDataIsland = document.all("xmlsenderdetails" & controlType)
    Set senderDetailsXml = CreateObject("MSXML2.DOMDocument")
    senderDetailsXml.load(senderDetailsXmlDataIsland)
    'Have to set the SelectionLanguage property here for the translate function to work with msxml3.dll!!
    senderDetailsXml.setProperty "SelectionLanguage", "XPath"
    Set getSenderDetails = senderDetailsXml
End Function

'Surrounds a string with double quotes
Function dQ(anyString)
    dQ = Chr(34) & anyString & Chr(34)
End Function