// ============================================================================================
// File name:    	client.js
// Created:      	21-Jan-2002
// Author:       	D. Allen-Williams
// Description:  	This file is included client-side by most pages for button effects, etc.
// Dependencies: 	
// Issues:       	
// ============================================================================================

function buttonOver(element) {
// Description:	 Effect for button over event - change element class
// Pass:         HTML page element
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        			Comments
// 20-May-2001	 F.Edridge / P. Duxbury		Created
// -----------------------------------------------------
	window.document.all(element.id).className='buttondn';
}
	
// ============================================================================================
function buttonOut(element) {
// Description:	 Effect for button out event - change element class
// Pass:         HTML page element
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        			Comments
// 20-May-2001	 F.Edridge / P. Duxbury		Created
// -----------------------------------------------------
	window.document.all(element.id).className='buttonup';
}
	
// ============================================================================================
function getRelativeURL(sURL) {
/******************************************************************************
Description:  Converts URL passed to a relative URL
Author:       Dorothee Huck
Created:      June 2002              
*******************************************************************************/            

    var sMyURL, sAbsTargetURL, sRelTargetURL, sBaseURL;
    var iMySlashCount = 0;
    var iBaseSlashCount = 0;
    var iSlashDifToBase = 0;
    var oRegExp, result, i;
    var iRelURLStart = 0;
    var iTargetURLlength = 0;
    var sSSL = "https://";            //initialise
    
    if (sURL.indexOf("//") != -1) {
        sAbsTargetURL = sURL;
    }
    else {
        //we already have a relative URL
        return sURL;
    }

    sBaseURL = BASE_URL;
    sMyURL = document.URL;
    
    //strip out http/https prefixes in case the differ between current URL
    //and target URL    
    if (sAbsTargetURL.indexOf(sSSL) != -1) {
        oRegExp = new RegExp(sSSL,"i");      //Create regular expression object.
        sAbsTargetURL = sAbsTargetURL.replace(oRegExp, "")
    }
    else {
        oRegExp = new RegExp("http://","i");      //Create regular expression object.
        sAbsTargetURL = sAbsTargetURL.replace(oRegExp, "")
    }
    if (sMyURL.indexOf(sSSL) != -1) {
        oRegExp = new RegExp(sSSL,"i");      //Create regular expression object.
        sMyURL = sMyURL.replace(oRegExp, "")
    }
    else {
        oRegExp = new RegExp("http://","i");      //Create regular expression object.
        sMyURL = sMyURL.replace(oRegExp, "")
    }
    if (sBaseURL.indexOf(sSSL) != -1) {
        oRegExp = new RegExp(sSSL,"i");      //Create regular expression object.
        sBaseURL = sBaseURL.replace(oRegExp, "")
    }
    else {
        oRegExp = new RegExp("http://","i");      //Create regular expression object.
        sBaseURL = sBaseURL.replace(oRegExp, "")
    }

    //we must assume that BASE_URL is part of the target URL
    //search for base URL in target URL
    iRelURLStart = sBaseURL.length;
    iTargetURLLength = sAbsTargetURL.length;
    sRelTargetURL = sAbsTargetURL.substring(iRelURLStart, iTargetURLLength);
    
    // now check how far down the directory structure we are from the base URL
    oRegExp = new RegExp("/","g");      //Create regular expression object
    result = sMyURL.match(oRegExp);     //Attempt match on search string
    iMySlashCount = result.length;
    
    result = sBaseURL.match(oRegExp);      //Attempt match on search string
    iBaseSlashCount = result.length;       //Get the number of matches (slashes)

    iSlashDifToBase = iMySlashCount - iBaseSlashCount;
    if (iSlashDifToBase > 0) {
        for (i=1;i<=iSlashDifToBase;i++) {
            sRelTargetURL = "../" + sRelTargetURL;
        }
    }
    
    return sRelTargetURL;
}

// ============================================================================================
function postToURL(sURL, sForm, sItems, sValues, objPopup)	{
// Description:	 Dynamically builds a hidden form using the item/value array pairs, to be
//				 posted to the specified URL.
// Pass:         sURL    - the URL to be redirected to
//				 sForm   - the form name to use
//               aItems  - array of hidden input names
//               aValues - array of corresponding input values
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        			Comments
// 25-Jan-2002	 D.Allen-Williams			Created
// -----------------------------------------------------
	var objDoc
	var objBody
	
	// User feedback
	document.body.style.cursor = "wait";

    sURL = getRelativeURL(sURL);

	//submitting to a popup
	if(objPopup != null){
		objDoc = objPopup.document;	
	}
	else{
		objDoc = window.document;
	}

	// Insert the form if it doesn't already exist
	if (!(objDoc.all(sForm))) {
		if(objDoc.body == null){
			objBody = objDoc.createElement("body")
			objDoc.appendChild(objBody)
		}
		objDoc.body.insertAdjacentHTML('beforeEnd', ('<div style="visibility: hidden; position: absolute; top: 0px; left: 0px;"><form id="' + sForm + '" name="' + sForm + '"></form></div>'));
	}

	objDoc.forms(sForm).action = sURL;
	objDoc.forms(sForm).method = "post";

	//19-Aug-2002, M.Meere - adding the session to the form 
	addSessionToForm(sForm, "fldClientSession", document.all("fldSession").value, objDoc);
	
	// Get the form inputs & corresponding values
	aItems = sItems.split(";");
	aValues = sValues.split(";");
	for(i = 0; i < aItems.length; i++) {	
		if ((aItems[i].length) > 0) {
			// Insert the form item if it doesn't already exist
			if (!(objDoc.forms(sForm).elements(aItems[i]))) {
				objDoc.forms(sForm).insertAdjacentHTML("beforeEnd", "<input type=\'hidden\' id=\'" + aItems[i] + "\' name=\'" + aItems[i] + "\' \/>");
			}
            objDoc.forms(sForm)(aItems[i]).value = aValues[i];
		}
	}
	
	// Post the form	
	objDoc.forms(sForm).submit();	
	
	document.body.style.cursor = "auto";
	
	objDoc = null;
}

function addSessionToForm(strFormElement, strFieldName, strSessionValue, objDocument){
	var strSession
	var objSession
	var objFld
	
	objFld = eval('objDocument.forms("' + strFormElement + '").' + strFieldName);
	
	//check to see if the session field exists in the html before adding it.
	//if so change the session information
	if(!objFld){
		objSession			=	objDocument.createElement("INPUT");
		objSession.id		=	strFieldName;
		objSession.name		=	strFieldName;
		objSession.type		=	"hidden";
		objSession.value	=	strSessionValue;

		objDocument.forms(strFormElement).appendChild(objSession);
	}
	else{
		objFld.value = strSessionValue;
	}
	
	objDocument = null;
	objSession = null;
	objFld = null;
}

// ============================================================================================
function changeClass(element, className) {
// Description:	 Effect for button over event - change element class
// Pass:         HTML page element
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        			Comments
// 25-Jan-2002	 D.Allen-Williams			Created
// -----------------------------------------------------
	window.document.all(element.id).className=className;
}

// ============================================================================================
function aboutBox(appName, appRelease, version, basePath, strInstance, strComputer) {
// Description:	 Opens application information (similar to std About Box) in a new window
// Pass:         appName     - the application name
//               appRelease  - the application release number
//               version     - the (minor) version of the application
//               basePath    - the base URL path for retrieving logo graphics
//               instance    - the instance in use
//               computer    - computer name
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        			Comments
// 25-Jan-2002	 D.Allen-Williams			Created
// -----------------------------------------------------

    var myWin = window.open("about:blank", "about", "location=no, toolbar=no, menubar=no, top=50, left=50, resizeable=no, width=360, height=160", "true");

	var strHTML = "";
    strHTML += '<table border=0 cellspacing=0 cellpadding=0><tr>';
    strHTML += '<td><img id=\"nhssLogo\" src=\"' + basePath + 'graphics/nhssLogo.gif\" border=0></td>';
    strHTML += '<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>';
    strHTML += '<td valign=top>' ;
    strHTML += '<table border=0 cellspacing=0 cellpadding=0 style=\"FONT-FAMILY: Tahoma, Arial, Verdana, Geneva, Helvetica, sans-serif; FONT-SIZE: 12px;\">' ;
    
    strHTML += '<tr><td colspan=\"2\" style=\"FONT-SIZE: 14px;\"><b>' + appName + '</b></td></tr>';
    
    strHTML += '<tr><td>&nbsp;</td></tr>'
    
    strHTML += '<tr><td><b>Instance:</b></td><td>' + strInstance + '</td></tr>' ;
    strHTML += '<tr><td><b>Server:</b></td><td>' + strComputer + '</td></tr>' ;
    strHTML += '<tr><td><b>Release:</b></td><td>' + appRelease + '</td></tr>' ;
    strHTML += '<tr><td><b>Version:</b></td><td>' + version + '</td></tr>' ;
    strHTML += '<tr><td><b>ActiveGPASS:</b></td><td>' + getActiveGPASSVersion() + '</td></tr>' ;

    strHTML += '<tr><td>&nbsp;</td></tr>'
    
    strHTML += '<tr><td colspan=\"2\">Copyright &copy; CSA (ISD) 2000<br></td></tr>';
    
    

    strHTML += '</table>' ;
    strHTML += '</td></tr></table>';

    myWin.document.title = 'About ' + appName;
	myWin.document.body.innerHTML = strHTML;

}

// ============================================================================================
// MENU DISPLAY FUNCTIONS
// ============================================================================================
function displayMenu() {
// Description:	 Displays the context menu
// Pass:         None
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        		Comments
// 01-Feb-2002	 S.Tunstall             Created
// 18-Apr-2002	 D.Allen-Williams       Redeveloped for windows type skin & positioning
// -----------------------------------------------------

    // Find out how close the mouse is to the corner of the window
    var rightedge  = document.body.clientWidth  - event.clientX
    var bottomedge = document.body.clientHeight - event.clientY
    
    // If the horizontal distance isn't enough to accomodate the width of the context menu
    if (rightedge < contextMenu.offsetWidth)
        // Move the horizontal position of the menu to the left by it's width
        contextMenu.style.left = document.body.scrollLeft + event.clientX - contextMenu.offsetWidth - 130;
    else
        // position the horizontal position of the menu where the mouse was clicked
        contextMenu.style.left = document.body.scrollLeft + event.clientX - 130;
    
    // Same concept with the vertical position
    if (bottomedge < contextMenu.offsetHeight)
        contextMenu.style.top = document.body.scrollTop + event.clientY - contextMenu.offsetHeight;
    else
        contextMenu.style.top = document.body.scrollTop + event.clientY;

    contextMenu.style.display = "block";
    event.cancelBubble = true;
    return false;
}

// ============================================================================================
function closeMenu()
// Description:	 Called from the "document.onclick()" handler
// Pass:         None
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        		Comments
// 01-Feb-2002	 S.Tunstall             Created
// -----------------------------------------------------
{
    if (contextMenu)
    {
        contextMenu.style.display = "none";
    }
}

// ============================================================================================
function highlightMenu(){
// Description:	 Highlights a menu item
// Pass:         None
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        		Comments
// 01-Feb-2002	 S.Tunstall             Created
// 18-Apr-2002	 D.Allen-Williams       Redeveloped for windows type skin & positioning
// -----------------------------------------------------

    if (event.srcElement.className=="menuItem") {
        event.srcElement.style.backgroundColor="highlight";
        event.srcElement.style.color="white";
    }
}

// ============================================================================================
function lowlightMenu(){
// Description:	 Removes the highlight from a menu item
// Pass:         None
// Return:       None
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        		Comments
// 01-Feb-2002	 S.Tunstall             Created
// 18-Apr-2002	 D.Allen-Williams       Redeveloped for windows type skin & positioning
// -----------------------------------------------------

    if (event.srcElement.className=="menuItem"){
        event.srcElement.style.backgroundColor="";
        event.srcElement.style.color="black";
    }
}

// ============================================================================================
function getActiveGPASSVersion(){
// Description:	 Returns the version of ActiveGPASS on client machine
// Pass:         None
// Return:       String value of the DLL version
// Raise Errors: None
// -----------------------------------------------------
// Date       	 Developer        	Comments
// 14-Aug-2002	 R.Gooch             	Created
// -----------------------------------------------------

	var oActiveGPASS
	var sVersion
	var sNotInstalled
	
	sVersion = "";
	sNotInstalled = "<b>Not Installed</b>";
	
	try{
		oActiveGPASS = new ActiveXObject("activeGPASS.application");
		if ( oActiveGPASS != null ) {
	        sVersion = oActiveGPASS.DllVersion;
		}
		else{
			sVersion = sNotInstalled;
		}
	}	
	catch(e){
		sVersion = sNotInstalled;
	}
    
    return sVersion;
}

function handleKeyPress(){
	try{
		//when the tab button is hit, set focus on the instance combo
		if (window.event.keyCode==9){
			document.all('logonButton').focus();
		}
	
		//click on the logon button when the enter key is hit
		if (window.event.keyCode==13){
			document.all('logonbutton').click();
		}
	}
	catch(e){
	}
}

function jsCheckIfExists(object)
{
	return(typeof(object));
}
