Option Explicit
'============================================================================================
' File name:    default.vbs
' Description:  VB Script associated with default page of Protocol Verification Tool.
'============================================================================================

Const STANDALONE    = "standalone"
Const WEBSERVER     = "webserver"
Const PVT_INI       = "C:\Program Files\SCI\pvt.ini"
Dim m_objVerifyWindow	'As HTML Window
Dim m_objProtocolWindow 'As DHTML.Window
Set m_objVerifyWindow = Nothing
Set m_objProtocolWindow = Nothing

Function GetClientProtocolWorkingDirObj()   Set GetClientProtocolWorkingDirObj = document.getElementById("clientProtocolDir") End Function
Function GetServerProtocolWorkingDirObj()   Set GetServerProtocolWorkingDirObj = document.getElementById("serverProtocolDir") End Function
Function GetClientStylesheetWorkingDirObj() Set GetClientStylesheetWorkingDirObj = document.getElementById("clientStylesheetDir") End Function
Function GetServerStylesheetWorkingDirObj() Set GetServerStylesheetWorkingDirObj = document.getElementById("serverStylesheetDir") End Function

Function GetClientProtocolWorkingDirValue()     GetClientProtocolWorkingDirValue = GetClientProtocolWorkingDirObj().value End Function
Function GetServerProtocolWorkingDirValue()     GetServerProtocolWorkingDirValue = GetServerProtocolWorkingDirObj().value End Function
Function GetClientStylesheetWorkingDirValue()   GetClientStylesheetWorkingDirValue = GetClientStylesheetWorkingDirObj().value End Function
Function GetServerStylesheetWorkingDirValue()   GetServerStylesheetWorkingDirValue = GetServerStylesheetWorkingDirObj().value End Function

Function GetProtocolListObj()               Set GetProtocolListObj = document.getElementById("protocolXmlFiles") End Function
Function GetParkedDataListObj()             Set GetParkedDataListObj = document.getElementById("dataEntryFiles") End Function
Function GetStylesheetListObj()             Set GetStylesheetListObj = document.getElementById("stylesheetFiles") End Function

Function GetClientProtocolPath()            GetClientProtocolPath = GetProtocolListObj().value End Function
Function GetServerProtocolPath()            GetServerProtocolPath = Replace(GetClientProtocolPath(), GetClientProtocolWorkingDirValue(), GetServerProtocolWorkingDirValue(),1 ,1 ,1) End Function
Function GetClientDataEntryPath()           GetClientDataEntryPath = GetParkedDataListObj().value End Function
Function GetClientStylesheetPath()          GetClientStylesheetPath = GetStylesheetListObj().value End Function
Function GetServerStylesheetPath()          GetServerStylesheetPath = Replace(GetClientStylesheetPath(), GetClientStylesheetWorkingDirValue(), GetServerStylesheetWorkingDirValue(),1 ,1 ,1 ) End Function

Function GetPvtHeaderInnerText()            GetPvtHeaderInnerText = document.getElementById("pvtHeader").innerHtml End Function
Function GetMessageTypeId()                 GetMessageTypeId = document.getElementById("messageTypeId").value End Function
Function GetTargetSchemaString()            GetTargetSchemaString = document.getElementById("targetSchemaString").value End Function
Function GetIsThirdParty()                  GetIsThirdParty = document.getElementById("isThirdParty").value End Function

Function GetPvtServerProtocolPath()
    Dim result
    If GetSelectedConfiguration() = WEBSERVER Then
        result = GetServerProtocolPath()
    Else
        result = GetClientProtocolPath()
    End If
    GetPvtServerProtocolPath = result
End Function

Function GetPvtServerStylesheetPath()
    Dim result
    If GetSelectedConfiguration() = WEBSERVER Then
        result = GetServerStylesheetPath()
    Else
        result = GetClientStylesheetPath()
    End If
    GetPvtServerStylesheetPath = result
End Function

Sub MatchDisplayToConfiguration()
    Dim serverControlsActive
    Dim textColor
    If GetSelectedConfiguration() = WEBSERVER Then
        serverControlsActive = ""
        textColor = ""
    Else
        serverControlsActive = "readonly"
        textColor = "gray"
    End If
    
    ' Done like this because:
    ' - if disabled, then can't read server side
    ' - if only readonly, not grayed
    ' - so need to set readonly & need to set a color
    document.getElementById("serverProtocolDirRow").style.color = textColor
    document.getElementById("serverProtocolDir").style.color = textColor
    document.getElementById("serverProtocolDir").readonly = serverControlsActive
    document.getElementById("serverStylesheetDirRow").style.color = textColor
    document.getElementById("serverStylesheetDir").style.color = textColor
    document.getElementById("serverStylesheetDir").readonly = serverControlsActive
End Sub

Function SaveDefaultConfigurationToFile()
    If Not SaveTextToFile(PVT_INI, GetSelectedConfiguration()) Then
        Call MsgBox("An error occurred saving the default web server location.", , GetPvtHeaderInnerText())
    End If
End Function

Sub FixFolderLocationValue(folderLocationTextBox)
    If (Len(folderLocationTextBox.value) > 0) And (Right(folderLocationTextBox.value, 1) <> "\") Then
        folderLocationTextBox.value = folderLocationTextBox.value & "\"
    End If	  
End Sub

Sub MessageTypeIdOnChangeHandler()
    If Not GetProtocolListObj() is Nothing Then
        GetProtocolListObj().selectedIndex = 0
    End If
    If Not GetParkedDataListObj() is Nothing Then
        GetParkedDataListObj().selectedIndex = 0
    End If
    document.forms("defaultForm").submit()
End Sub

Sub RefreshProtocolList()
    Call RefreshOptionsFileList(GetProtocolListObj(), GetClientProtocolWorkingDirValue(), "xml")
    Call ShowEditDetails()
End Sub

Sub RefreshDataEntryList()
    Call RefreshOptionsFileList(GetParkedDataListObj(), GetClientProtocolWorkingDirValue(), "dat")
End Sub

Sub RefreshStylsheetList()
    Call RefreshOptionsFileList(GetStylesheetListObj(), GetClientStylesheetWorkingDirValue(), "xslt")
End Sub

Sub RefreshAllLists()
    Call RefreshProtocolList()
    Call RefreshDataEntryList()
    Call RefreshStylsheetList()
End sub

Sub ViewForm()
    Call GetThirdPartyPatientXml()
    Call MakeMessage()
End Sub

Sub VerifyProtocol(verifyPageAddress, pvtServerProtocolPath)
    If Not ValidateProtocolDirValue() Then Exit sub
    If Not ValidateProtocolPath() Then Exit Sub
  
    Dim objForm
	Set objForm = CloseAndOpenNewVerificationForm(verifyPageAddress)
    Call objForm.insertAdjacentHTML("beforeEnd", _
        "<input name='pvtServerProtocolPath' type='hidden' value='" & pvtServerProtocolPath & "'>" & _
        "<input name='clientxml' type='hidden' value='" & GetClientProtocolPath() & "'>" & _
        "<input name='Configuration' type='hidden' value='" & GetSelectedConfigurationId() & "'>" & _
        "<input name='clientProtocolDir' type='hidden' value='" & GetClientProtocolWorkingDirValue() & "'>" & _
        "<input name='serverProtocolDir' type='hidden' value='" & GetServerProtocolWorkingDirValue() & "'>" & _		
        "<input name='msgtype' type='hidden' value='" & GetMessageTypeId() & "'>" & _
        "<input name='targetSchemaString' type='hidden' value='" & GetTargetSchemaString() & "'>")
    objForm.submit()    
End Sub

Sub Verify()
    If Not ValidatePvtServerProtocolPath() Then Exit Sub
    Call VerifyProtocol("message/verify.asp", GetPvtServerProtocolPath())
End Sub

Sub VerifyAll()
    If Not ValidateProtocolDirValue() Then Exit Sub
    Dim objForm
    Set objForm = CloseAndOpenNewVerificationForm("message/verifyall.asp")
    Call objForm.insertAdjacentHTML("beforeEnd", _
        "<input name='Configuration' type='hidden' value='" & GetSelectedConfigurationId() & "'>" & _
        "<input name='clientProtocolDir' type='hidden' value='" & GetClientProtocolWorkingDirValue() & "'>" & _
        "<input name='serverProtocolDir' type='hidden' value='" & GetServerProtocolWorkingDirValue() & "'>" & _
        "<input name='msgtype' type='hidden' value='" & GetMessageTypeId() & "'>" & _
        "<input name='targetSchemaString' type='hidden' value='" & GetTargetSchemaString() & "'>")
    objForm.submit()	
End Sub

Function LaunchXmlEditor()
    If Not ValidateProtocolPath() Then Exit Function
    document.getElementById("protFile").value = GetClientProtocolPath()
    document.getElementById("protDir").value = GetClientProtocolWorkingDirValue()
    document.getElementById("ConfigurationSetting").value = GetSelectedConfigurationId()
    Call OpenXML(False, "message/protxml.html", False)
End Function

Sub RefreshOptionsFileList(selectControl, directory, fileExtension)
    Dim blnRefresh
    blnRefresh = False
    If GetSelectedConfiguration() = WEBSERVER Then
        If IsNetworkDrive(Left(directory, 2)) Then
            If (Right(directory, 2) = ":\") Or (Right(directory, 1) = ":") Then
                blnRefresh = CBool(MsgBox( _
                        "Searching the " & Left(directory, Len(directory) - 1) _
                        & " drive for files may take some time." & vbCrLf _
                        & "Are you sure you wish to continue?", _
                        36, GetPvtHeaderInnerText()) = 6)
            End If
        Else
            blnRefresh = False
            Call MsgBox(directory & " is not a valid network drive.", , GetPvtHeaderInnerText())
        End If
    Else
        blnRefresh = True
    End If
    
    Call PopulateDropDownFromInputPathFiles(selectControl, directory, fileExtension)
End Sub

Sub PopulateDropDownFromInputPathFiles(selectControl, directory, fileExtension) 'As Boolean
    On Error Resume Next
    Dim oFS     'As Scripting.FileSystemObject
    Set oFS = CreateObject("Scripting.FileSystemObject")
    If Err.Number = 0 And Not oFS Is Nothing Then
        Dim oFolder
        Set oFolder = oFS.GetFolder(directory)
        selectControl.options.length = 0
        If Err.Number = 0 And Len(directory) > 0 Then
            If (GetSelectedConfiguration() = STANDALONE) Or (GetSelectedConfiguration() = WEBSERVER AND IsNetworkDrive(Left(directory, 2))) Then
                Call selectControl.add(CreateOptionControl("", "", "(Select File)"))
                Call AddDirectoriesFilesAsOptions(selectControl, oFolder, directory, fileExtension)
            Else
                selectControl.options.length = 0
                Call selectControl.add(CreateOptionControl("", "", "(invalid working directory)"))
            End If
        Else
            Call selectControl.add(CreateOptionControl("", "", "(invalid working directory)"))
        End If
        Set oFolder = Nothing
    End If
    
    ' Cleanup
    Err.Clear
    Set oFS = Nothing
    On Error Goto 0
End Sub

Sub AddDirectoriesFilesAsOptions(selectControl, ByVal oFolder, directory, fileExtension)
    ' Append files of type fileExtension
    Dim oFile           'As Scripting.File
    For Each oFile In oFolder.Files
        If LCase(Right(oFile.Name, Len(fileExtension) + 1)) = "." & LCase(fileExtension) Then
            Call selectControl.add(CreateOptionControl(oFile.Path, oFile.Path, oFile.Name))
        End If
    Next
    Set oFile = Nothing
    
    ' Append children folders
    Dim oSubFolder      'As Scripting.Folder
    For Each oSubFolder In oFolder.SubFolders
    	Call selectControl.add(CreateOptionControl("", "", ""))            
    	Call selectControl.add(CreateOptionControl("", "", "---- " & oSubFolder.Name & " ----"))
        Call AddDirectoriesFilesAsOptions(selectControl, oSubFolder, directory, fileExtension)
    Next
    Set oSubFolder = Nothing
End Sub

Function CreateOptionControl(id, value, text)
    Dim newOption
    Set newOption = document.createElement("option")
    newOption.id = id
    newOption.value = value
    newOption.text = text
    Set CreateOptionControl = newOption
End Function

Sub ShowEditDetails()
    Dim blnEdit
    blnEdit = Not(Right(LCase(GetClientProtocolPath()), 4) = ".xml")
    document.getElementById("butVerify").disabled = blnEdit
    document.getElementById("butMake").disabled = blnEdit
    document.getElementById("butXMLEditor").disabled = blnEdit
End Sub

Sub MakeMessage()
    If Not ValidateProtocolDirValue() Then Exit Sub
    If Not ValidatePvtServerProtocolPath() Then Exit Sub
    If Not ValidateStylesheetDirValue() Then Exit Sub    
    If Not ValidatePvtServerStylesheetPath() Then Exit Sub
    Call CreateNewProtocolWindowForm().Submit()
End Sub

Function CreateNewProtocolWindowForm()
    On Error Resume Next
    m_objProtocolWindow.close()
    On Error GoTo 0
    Set m_objProtocolWindow = window.open("about:blank", _
                                "", _
                                "location=no, toolbar=no, menubar=no, top=0, left=0, width=786, height=540, resizable=yes")
    While Not m_objProtocolWindow.document.readyState = "complete" 
    Wend
    
    Dim objForm
    Set objForm     =   m_objProtocolWindow.document.createElement("FORM")
    objForm.id      =   "messageinfo"
    objForm.name    =   "messageinfo"
    objForm.action  =   "message/viewprotocol.asp"
    objForm.method  =   "post"
    Set objForm = m_objProtocolWindow.document.body.appendChild(objForm)	
    Call AddProtocolWindowFormHiddenFields(objForm)
    Set CreateNewProtocolWindowForm = objForm
End Function

Sub AddProtocolWindowFormHiddenFields(objForm)
' Description:  Add patient key and custom gateway fields
    Dim strStatus           'As String 
    Dim strPatientKey       'As String
    Dim strPatDetails       'As String

    'Check if a data file is being used
    If LCase(Right(GetClientDataEntryPath(), 4)) = ".dat" Then
        strStatus = "data"
        strPatientKey = ""
    Else
        strStatus = "new"
        If Not GetIsThirdParty() Then
            strPatientKey = GetGpassPatientKey()
        Else
            strPatientKey = CStr(document.getElementById("patientkey").value)
            strPatDetails = document.getElementById("patdetails").value        	
        End If
    End If
 
    ' The only message types that can be prepopulated from GPASS are referrals
    If (Not document.forms("gpassReferral") Is Nothing) And (strStatus <> "data") Then
        Call objForm.insertAdjacentHTML("beforeEnd", document.forms("gpassReferral").innerHTML)
    End If
    
    Call objForm.insertAdjacentHTML("beforeEnd", _
        "<input name='pvtServerProtocolPath' type='hidden' value='" & GetPvtServerProtocolPath() & "'>" & _
        "<input name='pvtClientProtocolPath' type='hidden' value='" & GetClientProtocolPath() & "'>" & _
        "<input name='dataEntryXmlPath' type='hidden' value='" & GetClientDataEntryPath() & "'>" & _
        "<input name='pvtServerStylesheetPath' type='hidden' value='" & GetPvtServerStylesheetPath() & "'/>" & _
        "<input name='status' type='hidden' value='" & strStatus & "'>" & _
        "<input name='msgtype' type='hidden' value='" & GetMessageTypeId() & "'/>" & _
        "<input name='targetSchemaString' type='hidden' value='" & GetTargetSchemaString() & "'/>" & _
        "<input name='protocolFormXslPath' type='hidden' value='" & document.getElementById("protocolFormXslPath").value & "'/>" & _
        "<input name='patientKey' type='hidden' value='" & strPatientKey & "'>" & _
        "<input name='isThirdParty' type='hidden' value=" & GetIsThirdParty() & ">" & _
        "<input name='patDetails' type='hidden' value='" & strPatDetails & "'>" & _
        "<input name='HospitalAddress' type='hidden' value='Main Street, Trumpton'>" & _
        "<input name='HospitalID' type='hidden' value='123456'>" & _
        "<input name='HospitalName' type='hidden' value='Trumpton Royal Infirmary'>" & _
        "<input name='HospitalTelephone' type='hidden' value=''>" & _
        "<input name='ProtocolName' type='hidden' value='Test Protocol'>" & _
        "<input name='ConsultantForename' type='hidden' value='Patrick'>" & _
        "<input name='ConsultantGrade' type='hidden' value='Consultant'>" & _
        "<input name='ConsultantID' type='hidden' value='123456'>" & _
        "<input name='ConsultantSurname' type='hidden' value='Hernandez'>" & _
        "<input name='SpecialtyName' type='hidden' value='General Medicine'>" & _
        "<input name='Provider' type='hidden' value=''>")
                    
    'Replace some message object fields with Gateway values
    If objForm.elements("Date") Is Nothing Then
        Call objForm.insertAdjacentHTML("beforeEnd", "<input name='Date' type='hidden' value='" & UnambiguousDate(Date()) & "'>")
    Else
        objForm.elements("Date").value = UnambiguousDate(Date())
    End If
End Sub

Function GetSelectedConfiguration()
    Dim result
    If document.getElementById("Configuration1").checked Then
        result = STANDALONE
    ElseIf document.getElementById("Configuration2").checked Then
        result = WEBSERVER
    Else
        result = STANDALONE
    End If
    GetSelectedConfiguration = result
End Function

Function GetSelectedConfigurationId()
    Dim intConfigSetting
    If GetSelectedConfiguration() = WEBSERVER Then
        intConfigSetting = 2
    Else
        intConfigSetting = 1
    End If
    GetSelectedConfigurationId = intConfigSetting
End Function

Sub SetDefaultConfigurationFromFile()
    Dim configuration
    configuration = LoadTextFromFile(PVT_INI)
    document.getElementById("Configuration1").checked = (configuration <> WEBSERVER)
    document.getElementById("Configuration2").checked = (configuration = WEBSERVER)
End Sub

Function CloseAndOpenNewVerificationForm(newFormAction)
    If Not m_objVerifyWindow Is Nothing Then
        On Error Resume Next
        m_objVerifyWindow.close()
        While Not m_objVerifyWindow.closed
        Wend
        On Error GoTo 0
    End If
    Set m_objVerifyWindow = window.open("about:blank", "verifyWindow", "toolbar=no,scrollbars=yes,left=20,top=10,width=925,height=600", True)
    While Not (m_objVerifyWindow.document.readyState = "complete")					
    Wend

    Dim objBody             'As HTML Body
    Dim objForm             'As HTML Form
    Set objBody = m_objVerifyWindow.document.CreateElement("body")
    Call m_objVerifyWindow.document.appendChild(objBody)
    Set objForm = m_objVerifyWindow.document.CreateElement("form")
    Call objBody.appendChild(objForm)
    objForm.id = "frmVerify"
    objForm.name = "frmVerify"
    objForm.action = newFormAction
    objForm.method = "post"
    Set CloseAndOpenNewVerificationForm = objForm
End Function

Sub GetThirdPartyPatientXml()
    'If we have come from a 3rd party app and have a patient key then populate the patient details data island 
    If (Len(document.getElementById("logontoken").value) > 0 and Len(document.getElementById("patientkey").value) > 0)Then
        Dim patientDetails
        retrievePatientDetails _
                            document.getElementById("appname").value, _
                            document.getElementById("progid").value, _
                            document.getElementById("patientkey").value, _
                            patientDetails
        document.getElementById("patdetails").value = patientDetails
        document.getElementById("isThirdParty").value = true
    End If	    
End Sub

Function GetFilePath(directory, filename)
    Dim result
    If Len(directory) > 0 And Len(filename) > 0 Then
        result = directory & filename
    Else
        result = ""
    End If
    GetFilePath = result
End Function

Function SaveTextToFile(strFileName, strText)
    Dim blnSuccess
    blnSuccess = False

    Dim objFSO
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    If objFSO.FileExists(strFileName) Then
        call objFSO.DeleteFile(strFileName, True)
    End If

    Dim objStream
    Set objStream = objFSO.CreateTextFile(strFileName)
    If Not objStream Is Nothing Then
        objStream.write strText
        objStream.close
        blnSuccess = objFSO.FileExists(strFileName)
    End If		

    Set objStream = Nothing
    Set objFSO = Nothing
    SaveTextToFile = blnSuccess
End Function

Function LoadTextFromFile(strFilename)
    Dim result
    Dim objFSO
    
    result = ""
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    If objFSO.FileExists(strFilename) Then
        Dim objFile
        Set objFile = objFSO.OpenTextFile(strFilename, 1)
        If Not objFile Is Nothing Then
            result = objFile.readAll()
        End If
        Set objFile = Nothing
    End If
    Set objFSO = Nothing
    
    LoadTextFromFile = result
End Function

Function FileExists(sFile)
    FileExists = CreateObject("Scripting.FileSystemObject").FileExists(sFile)
End Function 

Function FolderExists(strDir)
    FolderExists = CreateObject("Scripting.FileSystemObject").FolderExists(strDir)
End Function

Function IsNetworkDrive(strDrive)
    Dim oNetworkDrives
    Dim intCount
    Dim blnValid 

    blnValid = False
    Set oNetworkDrives = CreateObject("WScript.Network").EnumNetworkDrives()
    For intCount = 0 to oNetworkDrives.Count -1 Step 2
        If UCase(strDrive) = UCase(oNetworkDrives.Item(intCount)) Then
            blnValid = True
            Exit For
        End If
    Next

    Set oNetworkDrives = Nothing
    IsNetworkDrive = blnValid
End Function

Function ValidateProtocolDirValue()
    Dim result
    result = FolderExists(GetClientProtocolWorkingDirValue())
    If Not result Then Call MsgBox("Please provide a exisiting protocol working directory.", , GetPvtHeaderInnerText())
    ValidateProtocolDirValue = result
End Function

Function ValidateProtocolPath()
    Dim result
    result = FileExists(GetClientProtocolPath())
    If Not result Then Call MsgBox("Please provide an existing protocol xml file.", , GetPvtHeaderInnerText())
    ValidateProtocolPath = result
End Function

Function ValidatePvtServerProtocolPath()
    Dim result
    result = LCase(Right(GetPvtServerProtocolPath(), 4)) = ".xml"
    If Not result Then Call MsgBox("Please select a protocol .xml file to verify.", , GetPvtHeaderInnerText())
    ValidatePvtServerProtocolPath = result
End Function

Function ValidateStylesheetDirValue()
    Dim result
    result = FolderExists(GetClientStylesheetWorkingDirValue())
    If Not result Then Call MsgBox("Please provide a exisiting stylesheet working directory.", , GetPvtHeaderInnerText())
    ValidateStylesheetDirValue = result
End Function

Function ValidatePvtServerStylesheetPath()
    Dim result
    Dim hasLength : hasLength = Len(GetPvtServerStylesheetPath()) > 0
    Dim endsXslt : endsXslt = LCase(Right(GetPvtServerStylesheetPath(), 5)) = ".xslt"
    Dim endsXsl : endsXsl = LCase(Right(GetPvtServerStylesheetPath(), 4)) = ".xsl"
    result = Not hasLength Or (hasLength And (endsXslt Or endsXsl))
    If Not result Then Call MsgBox("Please select an XSLT protocol file to view. Protocol files must have the .XSLT or XSL extension", , GetPvtHeaderInnerText())
    ValidatePvtServerStylesheetPath = result
End Function