Option Explicit
'============================================================================================
' File name:    gpassEncounter.vbs
' Description:  This provides methods for extracting supported message properties used
'               by protocol definitions.  In particular, it assumes a bolt on to the standard
'               message object exposed by the NewGpass API.
'============================================================================================

Class Encounter

    'Decorated object
    Private m_objProtocolObj 'As ProtocolObject

    Private Sub Class_Initialize()
        Dim objEnc 'As NewGpass.Encounter

        Set m_objProtocolObj = New ProtocolObject
        Set objEnc = CreateObject("NewGpass.Encounter")

        If Not objEnc Is Nothing Then
            Call m_objProtocolObj.Use(objEnc)
        End If

        Set objEnc = Nothing
    End Sub

    Private Sub Class_Terminate()
        Set m_objProtocolObj = Nothing
    End Sub

    Public Sub Use(objBaseObject)
        Call m_objProtocolObj.Use(objBaseObject)
    End Sub

    Public Function GetProperty(strProperty) 'As Variant
        Dim varValue 'As Variant

        If vartype(m_objProtocolObj.GetProperty(strProperty)) = vbObject Then
            Set varValue = m_objProtocolObj.GetProperty(strProperty)
            Set GetProperty = varValue
        Else
            varValue = m_objProtocolObj.GetProperty(strProperty)
            GetProperty = varValue
        End If
    End Function

    Public Sub LetProperty(strProperty, varValue)    
        Call m_objProtocolObj.LetProperty(strProperty, varValue)
    End Sub

    Public Sub DoMethod(strMethodName)
        Call m_objProtocolObj.doMethod(strMethodName)
    End Sub

End Class
