'============================================================================================
' File name:        gpassPrescribedDrug.vbs
' Created:          17-Jun-2002
' Author:           D. Allen-Williams
' Description:      This provides methods for extracting supported Clinician properties used
'                   by protocol definitions.  In particular, it assumes a bolt on to the standard
'                   PrescribedDrug object exposed by the NewGpass API.
' Dependencies:     
' Issues:           
'============================================================================================

Option Explicit

Class PrescribedDrug

    'Decorated object
    Private m_objProtocolObj       'As ProtocolObject

    '---------------------------------------------
    Private Sub Class_Initialize()
        Set m_objProtocolObj = New ProtocolObject
    End Sub
    
    '---------------------------------------------
    Private Sub Class_Terminate()
        Set m_objProtocolObj = Nothing
    End Sub
    
    '---------------------------------------------
    Public Sub Use(objBaseObject)
        Call m_objProtocolObj.Use(objBaseObject)
    End Sub
    
    '---------------------------------------------
    Public Function GetProperty(strProperty)    'As Variant

        Dim varValue          'As Variant
        
        varValue = ""
        Select Case strProperty
        
            'Check for property that is currently only valid for Gpass R5 repeat prescriptions
            Case "DateStarted"
                varValue = m_objProtocolObj.GetProperty("Date")      'default to Date
                varValue = m_objProtocolObj.GetProperty(strProperty) 'attempt to grab DateStarted

            'Otherwise, assume it comes from the base object, overriding errors (hence providing a blank default)
            Case Else
                varValue = m_objProtocolObj.GetProperty(strProperty)
                        
        End Select
        GetProperty = varValue
        
    End Function
    
    '---------------------------------------------
    Public Sub LetProperty(strProperty, varValue)    

        'Assume it's a property of the base object
        Call m_objProtocolObj.LetProperty(strProperty, varValue)
        
    End Sub
    
End Class

