<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns="http://www.w3.org/1999/xhtml" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:pbr="http://www.show.scot.nhs.uk/isd/PBR" xmlns:ref="http://www.show.scot.nhs.uk/isd/Referral" xmlns:gen="http://www.show.scot.nhs.uk/isd/General" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:user="mailto:dorothee.huck@gpass.co.uk" exclude-result-prefixes="user msxsl">
	<xsl:output method="html" version="1.0" encoding="iso-8859-1" indent="yes" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
	<xsl:variable name="default_blank" select="'n/a'"/>
	<msxsl:script language="VBScript" implements-prefix="user"><![CDATA[
			'---------------------------------------------
			Function FormatLineBreaks(strText)
				Dim strOut

				strOut = Replace(strText, "<", "&lt;")
				strOut = Replace(strOut, ">", "&gt;")
				strOut = Replace(strOut, vbNewLine, "<br/>")
				strOut = Replace(strOut, vbCrLf, "<br/>")
				strOut = Replace(strOut, vbCr, "<br/>")
				strOut = Replace(strOut, vbLf, "<br/>")	
				FormatLineBreaks =  strOut 
			End Function

			'---------------------------------------------
			Function IsTime(tmTime)
				Dim strHour
				Dim strMinute
				Dim strSecond
				Dim lFirstColon
				Dim lSecondColon
				Dim arrMask(4)
				Dim lCount
				Dim bValidated

				IsTime = True
				arrMask(0) = "9:99"
				arrMask(1) = "99:99"
				arrMask(2) = "9:99:99"
				arrMask(3) = "99:99:99"
				strValTime = ""
				bValidated = False

				For lCount=0 to 3
					'the mask needs to be the same size as the time
					If Len(arrMask(lCount)) = Len(tmTime) Then
						'check the mask
						bValidated = ValidateMask(arrMask(lCount), tmTime)

						If bValidated Then
							lValMask = arrMask(lCount)
							Exit For							
						End If
					End If
				Next

				If bValidated Then
					'based on the mask check that the hours, minutes and seconds are okay (00:00:00-23:59:59)

					'get the colons
					lFirstColon = InStr(arrMask(lCount), ":")

					If lCount = 2 Or lCount = 3 Then
						lSecondColon = InStr(lFirstColon+1, arrMask(lCount), ":")
					Else
						lSecondColon = 0
					End If	

					'get the hours
					strHour = Mid(tmTime, 1, lFirstColon-1)
					IsTime = ValidateTimeLimit(strHour, 23)

					'get the minutes
					strMinute = Mid(tmTime, lFirstColon+1, 2)
					IsTime = ValidateTimeLimit(strMinute, 59)

					If Not (lSecondColon = 0) Then
						'get the seconds
						strSecond = Mid(tmTime, lSecondColon+1, 2)	
						IsTime = ValidateTimeLimit(strSecond, 59)
					End If

				Else
					IsTime = False
				End If
			End Function

			'---------------------------------------------
			Function ValidateTimeLimit(strTimeElement, lConstraint)
				ValidateTimeLimit = True

				If IsNumeric(strTimeElement) Then
					If Not (CInt(strTimeElement) <= lConstraint And CInt(strHour) >= 0) Then
						ValidateTimeLimit = False
					End If

				Else
					ValidateTimeLimit = False
				End If
			End Function

			'---------------------------------------------
			Function ValidateMask(strMask, strTime)
				Dim lCount
				Dim bValidated

				bValidated = True

				For lCount=1 to Len(strTime)
					If Mid(strMask, lCount, 1) = "9" Then
						'if the mask specifies a 9, check that the specified time has a number
						If Not IsNumeric(Mid(strTime, lCount, 1)) Then
							bValidated = False
							Exit For
						End If

					ElseIf Mid(strMask, lCount, 1) = ":" Then
						If Not Mid(strMask, lCount, 1) = Mid(strTime, lCount, 1) Then
							bValidated = False
							Exit For
						End If
					End If
				Next		

				ValidateMask = bValidated
			End Function

			'---------------------------------------------
			Function UnambiguousDateShortTime(dteDate, strDefault)
				Dim dteTempDate

				UnambiguousDateShortTime =   strDefault	
				dteDate = Replace(dteDate, "T", " ")

				''If Not IsNull(dteDate) Then
					If IsDate(dteDate) Then
						UnambiguousDateShortTime = UnambiguousDate(dteDate, strDefault) & " " & FormatDateTime(dteDate, 4)

					Else
						dteTempDate = Left( dteDate, InStr(dteDate, " "))
						dteTempTime = Right(dteDate, Len(dteDate) - InStr(dteDate, " "))

						If IsDate(dteTempDate) Then
							If IsTime(dteTempTime) Then
								UnambiguousDateShortTime = UnambiguousDate(dteTempDate, strDefault) & " " & FormatDateTime(dteTempTime, 4)
							Else
								UnambiguousDateShortTime = UnambiguousDate(dteTempDate, strDefault) & " " & dteTempTime
							End If
						End If
					End If
				''End If    
			End Function

			'---------------------------------------------
			Function UnambiguousDate(dteDate, strDefault)
				Dim     strDay           'As String
				Dim     strMonth         'As String
				Dim     strYear          'As String

				UnambiguousDate = strDefault

				''If Not IsNull(dteDate) Then
					If IsDate(dteDate) Then
						If Day(dteDate) < 10 Then
							strDay = "0" & CStr(Day(dteDate))
						Else
							strDay = CStr(Day(dteDate))    
						End If

						'strMonth = MonthName(Month(dteDate), True)
						If Month(dteDate) < 10 Then
							strMonth = "0" & CStr(Month(dteDate))
						Else
							strMonth = CStr(Month(dteDate))    
						End If

						strYear = CStr(Year(dteDate))
						UnambiguousDate = strDay & "." & strMonth & "." & strYear 
					End If			
				''End If   
			End Function

			'---------------------------------------------
			'Function ToUpper(strValue)
			'	ToUpper = UCase(CStr(strValue))
			'End Function

			'---------------------------------------------
			'Function ToLower(strValue)
			'	ToLower = LCase(CStr(strValue))
			'End Function
		]]></msxsl:script>
	<!-- ################################################################################################ -->
	<!-- ################################### Document Style & Layout #################################### -->
	<!-- ################################################################################################ -->
	<xsl:template match="/">
		<html>
			<head>
				<title>Referral Letter</title>
				<style type="text/css">
					/*
					Copyright (c) 2008, Yahoo! Inc. All rights reserved.
					Code licensed under the BSD License:
					http://developer.yahoo.net/yui/license.txt
					version: 2.6.0
					*/
					html{color:#000;background:#FFF;}body,div,dl,dt,dd,ul,ol,li,h1,h2,h3,h4,h5,h6,pre,code,form,fieldset,legend,input,textarea,p,blockquote,th,td{margin:0;padding:0;}table{border-collapse:collapse;border-spacing:0;}fieldset,img{border:0;}address,caption,cite,code,dfn,em,strong,th,var{font-style:normal;font-weight:normal;}li{list-style:none;}caption,th{text-align:left;}h1,h2,h3,h4,h5,h6{font-size:100%;font-weight:normal;}q:before,q:after{content:'';}abbr,acronym{border:0;font-variant:normal;}sup{vertical-align:text-top;}sub{vertical-align:text-bottom;}input,textarea,select{font-family:inherit;font-size:inherit;font-weight:inherit;}input,textarea,select{*font-size:100%;}legend{color:#000;}del,ins{text-decoration:none;}body{font:13px/1.231 arial,helvetica,clean,sans-serif;*font-size:small;*font:x-small;}select,input,button,textarea{font:99% arial,helvetica,clean,sans-serif;}table{font-size:inherit;font:100%;}pre,code,kbd,samp,tt{font-family:monospace;*font-size:108%;line-height:100%;}body{text-align:center;}#ft{clear:both;}#doc,#doc2,#doc3,#doc4,.yui-t1,.yui-t2,.yui-t3,.yui-t4,.yui-t5,.yui-t6,.yui-t7{margin:auto;text-align:left;width:57.69em;*width:56.25em;min-width:750px;}#doc2{width:73.076em;*width:71.25em;}#doc3{margin:auto 10px;width:auto;}#doc4{width:74.923em;*width:73.05em;}.yui-b{position:relative;}.yui-b{_position:static;}#yui-main .yui-b{position:static;}#yui-main,.yui-g .yui-u .yui-g{width:100%;}{width:100%;}.yui-t1 #yui-main,.yui-t2 #yui-main,.yui-t3 #yui-main{float:right;margin-left:-25em;}.yui-t4 #yui-main,.yui-t5 #yui-main,.yui-t6 #yui-main{float:left;margin-right:-25em;}.yui-t1 .yui-b{float:left;width:12.30769em;*width:12.00em;}.yui-t1 #yui-main .yui-b{margin-left:13.30769em;*margin-left:13.05em;}.yui-t2 .yui-b{float:left;width:13.8461em;*width:13.50em;}.yui-t2 #yui-main .yui-b{margin-left:14.8461em;*margin-left:14.55em;}.yui-t3 .yui-b{float:left;width:23.0769em;*width:22.50em;}.yui-t3 #yui-main .yui-b{margin-left:24.0769em;*margin-left:23.62em;}.yui-t4 .yui-b{float:right;width:13.8456em;*width:13.50em;}.yui-t4 #yui-main .yui-b{margin-right:14.8456em;*margin-right:14.55em;}.yui-t5 .yui-b{float:right;width:18.4615em;*width:18.00em;}.yui-t5 #yui-main .yui-b{margin-right:19.4615em;*margin-right:19.125em;}.yui-t6 .yui-b{float:right;width:23.0769em;*width:22.50em;}.yui-t6 #yui-main .yui-b{margin-right:24.0769em;*margin-right:23.62em;}.yui-t7 #yui-main .yui-b{display:block;margin:0 0 1em 0;}#yui-main .yui-b{float:none;width:auto;}.yui-gb .yui-u,.yui-g .yui-gb .yui-u,.yui-gb .yui-g,.yui-gb .yui-gb,.yui-gb .yui-gc,.yui-gb .yui-gd,.yui-gb .yui-ge,.yui-gb .yui-gf,.yui-gc .yui-u,.yui-gc .yui-g,.yui-gd .yui-u{float:left;}.yui-g .yui-u,.yui-g .yui-g,.yui-g .yui-gb,.yui-g .yui-gc,.yui-g .yui-gd,.yui-g .yui-ge,.yui-g .yui-gf,.yui-gc .yui-u,.yui-gd .yui-g,.yui-g .yui-gc .yui-u,.yui-ge .yui-u,.yui-ge .yui-g,.yui-gf .yui-g,.yui-gf .yui-u{float:right;}.yui-g div.first,.yui-gb div.first,.yui-gc div.first,.yui-gd div.first,.yui-ge div.first,.yui-gf div.first,.yui-g .yui-gc div.first,.yui-g .yui-ge div.first,.yui-gc div.first div.first{float:left;}.yui-g .yui-u,.yui-g .yui-g,.yui-g .yui-gb,.yui-g .yui-gc,.yui-g .yui-gd,.yui-g .yui-ge,.yui-g .yui-gf{width:49.1%;}.yui-gb .yui-u,.yui-g .yui-gb .yui-u,.yui-gb .yui-g,.yui-gb .yui-gb,.yui-gb .yui-gc,.yui-gb .yui-gd,.yui-gb .yui-ge,.yui-gb .yui-gf,.yui-gc .yui-u,.yui-gc .yui-g,.yui-gd .yui-u{width:32%;margin-left:1.99%;}.yui-gb .yui-u{*margin-left:1.9%;*width:31.9%;}.yui-gc div.first,.yui-gd .yui-u{width:66%;}.yui-gd div.first{width:32%;}.yui-ge div.first,.yui-gf .yui-u{width:74.2%;}.yui-ge .yui-u,.yui-gf div.first{width:24%;}.yui-g .yui-gb div.first,.yui-gb div.first,.yui-gc div.first,.yui-gd div.first{margin-left:0;}.yui-g .yui-g .yui-u,.yui-gb .yui-g .yui-u,.yui-gc .yui-g .yui-u,.yui-gd .yui-g .yui-u,.yui-ge .yui-g .yui-u,.yui-gf .yui-g .yui-u{width:49%;*width:48.1%;*margin-left:0;}.yui-g .yui-g .yui-u{width:48.1%;}.yui-g .yui-gb div.first,.yui-gb .yui-gb div.first{*margin-right:0;*width:32%;_width:31.7%;}.yui-g .yui-gc div.first,.yui-gd .yui-g{width:66%;}.yui-gb .yui-g div.first{*margin-right:4%;_margin-right:1.3%;}.yui-gb .yui-gc div.first,.yui-gb .yui-gd div.first{*margin-right:0;}.yui-gb .yui-gb .yui-u,.yui-gb .yui-gc .yui-u{*margin-left:1.8%;_margin-left:4%;}.yui-g .yui-gb .yui-u{_margin-left:1.0%;}.yui-gb .yui-gd .yui-u{*width:66%;_width:61.2%;}.yui-gb .yui-gd div.first{*width:31%;_width:29.5%;}.yui-g .yui-gc .yui-u,.yui-gb .yui-gc .yui-u{width:32%;_float:right;margin-right:0;_margin-left:0;}.yui-gb .yui-gc div.first{width:66%;*float:left;*margin-left:0;}.yui-gb .yui-ge .yui-u,.yui-gb .yui-gf .yui-u{margin:0;}.yui-gb .yui-gb .yui-u{_margin-left:.7%;}.yui-gb .yui-g div.first,.yui-gb .yui-gb div.first{*margin-left:0;}.yui-gc .yui-g .yui-u,.yui-gd .yui-g .yui-u{*width:48.1%;*margin-left:0;} .yui-gb .yui-gd div.first{width:32%;}.yui-g .yui-gd div.first{_width:29.9%;}.yui-ge .yui-g{width:24%;}.yui-gf .yui-g{width:74.2%;}.yui-gb .yui-ge div.yui-u,.yui-gb .yui-gf div.yui-u{float:right;}.yui-gb .yui-ge div.first,.yui-gb .yui-gf div.first{float:left;}.yui-gb .yui-ge .yui-u,.yui-gb .yui-gf div.first{*width:24%;_width:20%;}.yui-gb .yui-ge div.first,.yui-gb .yui-gf .yui-u{*width:73.5%;_width:65.5%;}.yui-ge div.first .yui-gd .yui-u{width:65%;}.yui-ge div.first .yui-gd div.first{width:32%;}#bd:after,.yui-g:after,.yui-gb:after,.yui-gc:after,.yui-gd:after,.yui-ge:after,.yui-gf:after{content:".";display:block;height:0;clear:both;visibility:hidden;}#bd,.yui-g,.yui-gb,.yui-gc,.yui-gd,.yui-ge,.yui-gf{zoom:1;}
					/* Yahoo styles end, custom styles begin */


					/* General Styles - Set some defaults for common elements */
					.referral h1, .referral h2, .referral h3, .referral h4, .referral h5, .referral h6 { font-weight: bold; }
					.referral h1, .referral h2 { text-align: center; margin: 0px; padding: 0px; }

					.referral h1 { font-size: 138.5%; text-transform: uppercase; }
					.referral h2 { font-size: 131%; }
					.referral h3 { font-size: 108%; }
					.referral h3.clinicalInformation { border: 1px solid black; padding: 0.2em; margin-top: 1em; }
					.referral h3 span, .referral h4 span { font-weight: normal; text-transform: none; }
					.referral h4 { font-size: 108%; background-color:#aaa; border-top: 1px solid black; border-bottom: 1px solid black; }
					.referral h4.top { border-top: none; }
					.referral h5 { font-size: 108%; }
					.referral h6 { }

					.referral p { margin-bottom: 1em; }
					.referral p.address { margin: 0px; }
					.referral strong { font-weight: bold; }
					.referral em { font-style: italic; }

					.referral fieldset { border: 1px solid black; padding: 0.5em; }
					.referral legend { padding: 0em 0.3em;}

					.referral ol.semantic li { list-style-type: none; margin-left: 0em; }
					.referral ul.semantic li { list-style-type: none; margin-left: 0em; }

					.referral table { width:100%; }
					.referral th, .referral td { padding: 0.1em; }
					.referral th { background-color: #d4d4d4; border-bottom: 1px solid black; font-weight: bold; font-style: italic; }
					.referral td { border:1px dashed #aaa; vertical-align: top; } /* #eeeeee */

					.referral dl { }
					.referral dt { background-color: #d4d4d4; clear: both; float: left; width: 14em; border-top: 1px solid #aaa; padding-left: 0.2em; }
					.referral dd { margin-left: 14.25em; border-top: 1px solid #aaa; padding-left: 0.5em; clear:right; }
					.referral dl.gpDetails dt { width: 8em;}
					.referral dl.gpDetails dd { margin-left: 8.25em; }
					.referral dt.first { border: none;}
					.referral dd.first { border: none; }
					.referral dt.mid { border-bottom: 1px solid #aaa; }
					.referral dd.mid { border-bottom: 1px solid #aaa; }
					.referral dt.inline { background-color: #fff; width: auto; font-weight: bold; border: none;}
					.referral dd.inline { margin-left: 0px; border: none; }


					/* Common Class-Based Styles */
					.referral .highlight { background-color: black; color: white; font-weight: bold; padding: 0em 0.2em; }
					.referral .sectionContainer { clear: both; margin-top: 1em; }
					.referral .sectionData { border: 1px solid black; }					
					.referral .upperCase { text-transform: uppercase; }
					.referral .lowerCase { text-transform: lowercase; }
					.referral .titleCase { text-transform: capitalize; }


					/* Structural Page Styles */
					.referral .referral_header { border: 1px solid black; padding: 0.1em; }
					.referral .expedite { font-size: 116%; margin-top: 0.8em; }
					.referral .confidence { font-size: 116%; font-weight: normal; margin-top: 0.2em; }

					.referral .malignancy { font-size: 108%; }
					.referral .urgency { font-size: 108%; font-weight: bold; }
					.referral .urgency_soon{ font-style:italic; }
					.referral p.malignancy, .referral p.urgency {text-align: center; margin-bottom: 0.1em;}

					.referral .language{ clear: right; }
								
					/* slightly enhanced, universal clearfix hack */
					.referral .clearfix:after {
					visibility: hidden;
					display: block;
					font-size: 0;
					content: " ";
					clear: both;
					height: 0;
					}
					.referral .clearfix { display: inline-block; }
					/* start commented backslash hack \*/
					* html .clearfix { height: 1%; }
					.referral .clearfix { display: block; }
					/* close commented backslash hack */
				</style>
				<xsl:comment><![CDATA[[if ie 6]>
					<style type="text/css" media="print">
						.referral { zoom: 85%; }
					</style>
				<![endif]]]></xsl:comment>
			</head>
			<body>
				<div id="doc3" class="yui-t7">
					<xsl:comment> Workflow View Starts </xsl:comment>
					<div class="referral">
						<xsl:call-template name="referral_header"/>
						<xsl:call-template name="patient_details"/>
						<xsl:call-template name="general_practitioners"/>
						<xsl:call-template name="referral_to"/>
						<xsl:call-template name="clinical_information"/>
					</div>
					<xsl:comment> Workflow View Ends </xsl:comment>
					<div id="ft">
						<!-- footer goes here -->
					</div>
				</div>
			</body>
		</html>
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ################################### Document Title ############################################# -->
	<!-- ################################################################################################ -->
	<xsl:template name="referral_header">
		<div class="yui-gb referral_header">
			<div class="yui-u first">
				<h1>Referral Letter</h1>
				<h2 class="confidence">Medical In Confidence</h2>
			</div>
			<div class="yui-u">
				<xsl:choose>
					<xsl:when test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Is this an expedite letter?']]/gen:TestMeasurement/gen:MeasurementDescription[text()='EXPEDITE'])">
						<h2 class="expedite">
							<span class="highlight">EXPEDITE</span>
						</h2>
					</xsl:when>
					<xsl:otherwise>&#160;</xsl:otherwise>
				</xsl:choose>
			</div>
			<div class="yui-u">
				<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue='Urgent'">
					<p class="urgency">
						<span class="highlight">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue"/>
								</xsl:with-param>
							</xsl:call-template>
						</span>
					</p>
				</xsl:if>
				<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue='Urgent Suspected Cancer'">
					<p class="urgency">
						<span class="highlight">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue"/>
								</xsl:with-param>
							</xsl:call-template>
						</span>
					</p>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Suspected Malignancy?']]/gen:TestMeasurement/gen:MeasurementDescription">
						<p class="malignancy">
							<span class="highlight">
								<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Suspected Malignancy?']]/gen:TestMeasurement/gen:MeasurementDescription"/>
							</span>
						</p>
					</xsl:when>
					<xsl:otherwise>&#160;</xsl:otherwise>
				</xsl:choose>
			</div>
		</div>
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ################################### Patient Detail ############################################# -->
	<!-- ################################################################################################ -->
	<xsl:template name="patient_details">
		<div class="sectionContainer patientDetail clearfix">
			<h3>Patient Detail</h3>
			<div class="yui-g sectionData">
				<div class="yui-u first">
					<dl>
						<dt class="first">Full Name</dt>
						<dd class="first titleCase">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:Title"/>
								</xsl:with-param>
							</xsl:call-template>

							&#160;

							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:GivenName"/>
								</xsl:with-param>
							</xsl:call-template>
							<xsl:if test="substring-after(//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[starts-with(text(), 'Middle Name')], ':')">
								&#160;
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="substring-after(//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[starts-with(text(), 'Middle Name')], ':')"/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:if>

							&#160;

							<span class="upperCase">
								<xsl:choose>
									<xsl:when test="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientName[gen:NameType='Current Name']/gen:UnstructuredName">
										<xsl:value-of select="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientName[gen:NameType='Current Name']/gen:UnstructuredName"/>
									</xsl:when>
									<xsl:when test="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName">
										<xsl:value-of select="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$default_blank"/>
									</xsl:otherwise>
								</xsl:choose>
							</span>
						</dd>
						<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Other given names']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Other Given Names</dt>
							<dd class="titleCase">
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Other given names']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
						<dt>Sex</dt>
						<dd>
							<xsl:choose>
								<xsl:when test="//ref:MessageDataRef/ref:PatientDemographics/gen:Sex='F'">Female</xsl:when>
								<xsl:when test="//ref:MessageDataRef/ref:PatientDemographics/gen:Sex='M'">Male</xsl:when>
								<xsl:otherwise>Not specified</xsl:otherwise>
							</xsl:choose>
						</dd>
						<dt>Date of Birth</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="//ref:MessageDataRef/ref:PatientDemographics/gen:DateOfBirth"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
						<dt>NHS Number</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:ReferralDocument/ref:MessageDataRef/ref:PatientDemographics/gen:PatientId[gen:IdScheme[text()='NHS Number']]/gen:IdValue"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
						<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Hospital Number (CRN)']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Hospital Number (CRN)</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Hospital Number (CRN)']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
					</dl>
				</div>
				<div class="yui-u">
					<dl>
						<dt class="first">Patient's Address</dt>
						<dd class="first titleCase">
							<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientDemographics/gen:PatientAddress"/>
						</dd>
						<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Preferred contact telephone number']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Preferred Number</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Preferred contact telephone number']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
						<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Home telephone']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Home Telephone</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Home telephone']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
						<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Mobile telephone']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Mobile Telephone</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Mobile telephone']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
						<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Work telephone']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Work Telephone</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Work telephone']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
					</dl>
				</div>
				<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Interpreter Required?']]/gen:TestMeasurement/gen:MeasurementDescription[text() != 'No']">
					<div class="language">
						<div class="yui-u first">
							<dl>
								<dt>Interpreter Required</dt>
								<dd>
									<xsl:call-template name="format_text">
										<xsl:with-param name="text">
											<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Interpreter Required?']]/gen:TestMeasurement/gen:MeasurementDescription"/>
										</xsl:with-param>
									</xsl:call-template>
								</dd>
							</dl>
						</div>
						<div class="yui-u">
							<dl>
								<dt>Specified Language</dt>
								<dd>
									<xsl:call-template name="format_text">
										<xsl:with-param name="text">
											<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Please Specify Language']]/gen:TestMeasurement/gen:MeasurementDescription"/>
										</xsl:with-param>
									</xsl:call-template>
								</dd>
							</dl>
						</div>
					</div>
				</xsl:if>
			</div>
		</div>
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ######################################### Referral To ########################################## -->
	<!-- ################################################################################################ -->
	<xsl:template name="referral_to">
		<div class="sectionContainer referralTo clearfix">
			<h3>Referral To</h3>
			<div class="yui-g sectionData">
				<dl>
					<dt>Consultant/Practitioner</dt>
					<dd>
						<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:HcpReferredTo">
							<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:HcpReferredTo/gen:HcpName"/>
							<xsl:for-each select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:HcpReferredTo/gen:Position">
								(<xsl:value-of select="."/>)
							</xsl:for-each>
						</xsl:if>
					</dd>
					<dt>Specialty</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:ReferredToSpecialty/gen:SpecialtyName"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
					<dt>Preferred Provider Site</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="substring-after(//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[starts-with(text(), 'Preferred Provider Site')], ':')"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
					<xsl:if test="substring-after(//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[starts-with(text(), 'Reason for Preferred Site')], ':')">
						<dt>Reason for Preferred Site</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="substring-after(//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[starts-with(text(), 'Reason for Preferred Site')], ':')"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<dt>Date of GP Consultation</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:DateReferred"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
					<dt>Date Referral Sent</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:DateReferred"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
					<dt>Delivery Recipient</dt>
					<dd>
						<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationName"/>
						<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationAddress">
							<span class="titleCase">
								<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationAddress"/>
							</span>
						</xsl:if>
					</dd>
					<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationTelecom">
						<dt>Contact Number</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationTelecom[gen:TelecomType='Telephone']" mode="single"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationId/gen:IdValue">
						<dt>Hospital Unit No</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationId/gen:IdValue"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationTelecom[gen:TelecomType='Email']">
						<dt>Hospital Email Address</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralTo/ref:Hospital/gen:OrganisationTelecom[gen:TelecomType='Email']" mode="single"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<dt>Urgency of Referral</dt>
					<dd>
						<span class="urgency">
							<xsl:choose>
								<xsl:when test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue='Soon'">
									<xsl:attribute name="class">urgency_soon</xsl:attribute>
								</xsl:when>
								<xsl:when test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue='Urgent'">
									<xsl:attribute name="class">highlight</xsl:attribute>
								</xsl:when>
							</xsl:choose>
							<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyValue"/>
						</span>
						<xsl:if test="normalize-space(//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyReason)">
							- <xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralUrgencyReason"/>
						</xsl:if>
						<xsl:if test="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Suspected Malignancy?']]/gen:TestMeasurement/gen:MeasurementDescription">
							- <span class="malignancy highlight">
								<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Suspected Malignancy?']]/gen:TestMeasurement/gen:MeasurementDescription"/>
							</span>
						</xsl:if>
					</dd>
				</dl>
			</div>
		</div>
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ####################################### General Practitioners################################### -->
	<!-- ################################################################################################ -->
	<xsl:template name="general_practitioners">
		<div class="yui-g multiSectionContainer referringGp clearfix">
			<div class="yui-u first">
				<xsl:choose>
					<xsl:when test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:Referrer/ref:ReferringGP">
						<div class="sectionContainer">
							<h3>Referring GP</h3>
							<div class="sectionData">
								<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:Referrer/ref:ReferringGP"/>
							</div>
						</div>
					</xsl:when>
					<xsl:when test="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:Referrer/ref:ReferringParty">
						<div class="sectionContainer">
							<h3>Referring HCP</h3>
							<div class="sectionData">
								<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:Referrer/ref:ReferringParty"/>
							</div>
						</div>
					</xsl:when>
				</xsl:choose>
			</div>
			<div class="yui-u">
				<xsl:choose>
					<xsl:when test="//ref:MessageDataRef/ref:PatientDemographics/gen:RegisteredGp">
						<div class="sectionContainer">
							<h3>Registered GP</h3>
							<div class="sectionData">
								<xsl:apply-templates select="//ref:MessageDataRef/ref:PatientDemographics/gen:RegisteredGp"/>
							</div>
						</div>
					</xsl:when>
					<xsl:otherwise>&#160;</xsl:otherwise>
				</xsl:choose>
			</div>
		</div>
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ################################### CLINICAL INFORMATION ####################################### -->
	<!-- ################################################################################################ -->
	<xsl:template name="clinical_information">
		<h3 class="noTab clinicalInformation clearfix">
			Clinical Information <span>Additional information (including relevant examinations and investigations)</span>
		</h3>
		<div class="sectionContainer presentingComplaint clearfix">
			<h3>Presenting Complaint / Problem</h3>
			<div class="yui-g sectionData">
				<dl>
					<dt class="first">Reason for Referral</dt>
					<dd class="first">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:PresentingComplaint/gen:Diagnosis/gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
					<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:PresentingComplaint/gen:Diagnosis/gen:DateOfOnset">
						<dt class="mid">Date of Onset</dt>
						<dd class="mid">
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:PresentingComplaint/gen:Diagnosis/gen:DateOfOnset"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:PresentingComplaint/gen:Comment">
						<dt class="inline">Clinical Details (free text):&#160;</dt>
						<dd class="inline">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:PresentingComplaint/gen:Comment"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Select if related documents sent']]/gen:TestMeasurement/gen:MeasurementDescription">
						<dt>Related Documents Sent?</dt>
						<dd>Yes</dd>
						<dt>Specific Documents Sent</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Specify documents sent:']]/gen:TestMeasurement/gen:MeasurementDescription"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Special Instructions']]/gen:TestMeasurement/gen:MeasurementDescription">
						<dt class="inline">Additional Admin Details (free text):&#160;</dt>
						<dd class="inline">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Special Instructions']]/gen:TestMeasurement/gen:MeasurementDescription"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Patient will accept short notice appointment']]/gen:TestMeasurement/gen:MeasurementDescription">
						<dt>Further Information</dt>
						<dd>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Patient will accept short notice appointment']]/gen:TestMeasurement/gen:MeasurementDescription"/>
								</xsl:with-param>
							</xsl:call-template>
						</dd>
					</xsl:if>
					<dt>Care Type Requested</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralReason/ref:StructuredReferralReason/ref:CareTypeRequested"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
					<dt>Expected Outcome</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="//ref:MessageDataRef/ref:PatientAdministrationRef/ref:ReferralReason/ref:StructuredReferralReason/ref:ExpectedOutcome"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
				</dl>
			</div>
		</div>
		<!-- ################################################################################################ -->
		<!-- ################################### Clinical Warnings ########################################## -->
		<!-- ################################################################################################ -->
		<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:Allergy or //ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:Intolerance or //ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:RiskToOthers">
			<div class="sectionContainer clinicalWarnings clearfix">
				<h3>Risks and Warnings</h3>
				<div class="yui-gb sectionData">
					<div class="yui-u first">
						<h4 class="top">Allergies</h4>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:Allergy">
							<ul>
								<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:Allergy">
									<li>
										<xsl:value-of select="gen:Comment"/>
									</li>
								</xsl:for-each>
							</ul>
						</xsl:if>
					</div>
					<div class="yui-u">
						<h4 class="top">Intolerances</h4>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:Intolerance">
							<ul>
								<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:Intolerance">
									<li>
										<xsl:value-of select="gen:Comment"/>
									</li>
								</xsl:for-each>
							</ul>
						</xsl:if>
					</div>
					<div class="yui-u">
						<h4 class="top">Other Risks and Warnings</h4>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:RiskToOthers">
							<ul>
								<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:RiskToOthers">
									<li>
										<xsl:value-of select="gen:Comment"/>
									</li>
								</xsl:for-each>
							</ul>
						</xsl:if>
					</div>
				</div>
			</div>
		</xsl:if>
		<!-- ################################################################################################ -->
		<!-- ################################### Past Medical History ####################################### -->
		<!-- ################################################################################################ -->
		<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastCondition/gen:ConditionDisclosed or //ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastProcedure/gen:ProcedureDisclosed">
			<div class="sectionContainer pastMedicalHistory clearfix">
				<h3>Past Medical History</h3>
				<div class="yui-g sectionData">
					<div class="yui-u first">
						<!-- ################################################################################################ -->
						<!-- ####################################### Pre-Existing Conditions ################################ -->
						<!-- ################################################################################################ -->
						<h4 class="top">Problems / Diagnoses</h4>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastCondition/gen:ConditionDisclosed">
							<table>
								<tr>
									<th>Description</th>
									<th>Date Recorded</th>
								</tr>
								<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastCondition/gen:ConditionDisclosed">
									<tr>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:value-of select="gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="date">
													<xsl:value-of select="gen:DateOfOnset"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
								</xsl:for-each>
							</table>
						</xsl:if>
					</div>
					<div class="yui-u">
						<!-- ################################################################################################ -->
						<!-- ################################### Past Procedures ############################################ -->
						<!-- ################################################################################################ -->
						<h4 class="top">Operations and Procedures</h4>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastProcedure/gen:ProcedureDisclosed">
							<table>
								<tr>
									<th>Description</th>
									<th>Date Recorded</th>
								</tr>
								<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastProcedure/gen:ProcedureDisclosed">
									<tr>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalCircumstanceDescription"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="date">
													<xsl:value-of select="gen:DatePerformed"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
								</xsl:for-each>
							</table>
						</xsl:if>
					</div>
				</div>
			</div>
		</xsl:if>
		<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication) or normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord) or normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Comments on Medication(s)']]/gen:TestMeasurement/gen:MeasurementDescription[not('')])">
			<div class="sectionContainer medication clearfix">
				<h3>Medications</h3>
				<div class="yui-g sectionData">
					<!-- ################################################################################################ -->
					<!-- ################################### Current Medications ######################################### -->
					<!-- ################################################################################################ -->
					<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication)">
						<h4 class="top">
							Current Medication <span>(Active repeat medication issued within the last 12 months)</span>
						</h4>
						<xsl:choose>
							<xsl:when test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication)">
								<table>
									<tr>
										<th>Medication Code</th>
										<th>Medication Name</th>
										<th>Preparation</th>
										<th>Dose</th>
										<th>Frequency</th>
										<th>Started</th>
									</tr>
									<xsl:apply-templates select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication"/>
								</table>
							</xsl:when>
							<xsl:otherwise>
								<p>No current medications recorded.</p>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<!-- ################################################################################################ -->
					<!-- ################################### Recent Medication ########################################## -->
					<!-- ################################################################################################ -->
					<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord)">
						<h4>
							Recent Medication <span>(Any medication issued within the last 56 days not shown above)</span>
						</h4>
						<xsl:choose>
							<xsl:when test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord)">
								<table>
									<tr>
										<th>Medication Code</th>
										<th>Medication Name</th>
										<th>Preparation</th>
										<th>Dose</th>
										<th>Frequency</th>
										<th>Started</th>
										<th>Duration</th>
									</tr>
									<xsl:apply-templates select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord"/>
								</table>
							</xsl:when>
							<xsl:otherwise>
								<p>No recent medications recorded.</p>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Comments on Medication(s)']]/gen:TestMeasurement/gen:MeasurementDescription[not('')])">
						<h4>Comments on Medication(s)</h4>
						<div>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Comments on Medication(s)']]/gen:TestMeasurement/gen:MeasurementDescription"/>
								</xsl:with-param>
							</xsl:call-template>
						</div>
					</xsl:if>
				</div>
			</div>
		</xsl:if>
		<!-- ################################################################################################ -->
		<!-- ################################### Social History ############################################# -->
		<!-- ################################################################################################ -->
		<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Exercise status']]/gen:TestMeasurement/gen:MeasurementDescription or //ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Alcohol status']]/gen:TestMeasurement/gen:MeasurementDescription or //ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Smoking status']]/gen:TestMeasurement/gen:MeasurementDescription">
			<div class="sectionContainer socialHistory clearfix">
				<h3>Social History</h3>
				<div class="yui-g sectionData">
					<dl>
						<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Smoking status']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Smoking Status</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Smoking status']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
						<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Alcohol status']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Alcohol Status</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Alcohol status']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
						<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Exercise status']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<dt>Exercise Status</dt>
							<dd>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Exercise status']]/gen:TestMeasurement/gen:MeasurementDescription"/>
									</xsl:with-param>
								</xsl:call-template>
							</dd>
						</xsl:if>
					</dl>
				</div>
			</div>
		</xsl:if>
		<!--	################################################################################################ -->
		<!-- 	############################## Patient Measurements ############################################## -->
		<!--	################################################################################################ -->
		<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:PatientMeasurements">
			<div class="sectionContainer PatientMeasurements clearfix">
				<h3>Patient Measurements</h3>
			</div>
			<div class="yui-g">
				<table>
					<tr>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:PatientMeasurements/ref:BloodPressures">
							<td style="border:none;">
								<h3>Blood Pressures</h3>
								<div class="sectionData">
									<table>
										<tr>
											<th>BP Value</th>
											<th>Date Recorded</th>
										</tr>
										<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:PatientMeasurements/ref:BloodPressures/ref:BloodPressure">
											<tr>
												<td>
													<xsl:call-template name="format_text">
														<xsl:with-param name="text">
															<xsl:value-of select="./ref:Diastolic"/>
															<xsl:text>/</xsl:text>
															<xsl:value-of select="./ref:Systolic"/>
														</xsl:with-param>
													</xsl:call-template>
												</td>
												<td>
													<xsl:call-template name="format_text">
														<xsl:with-param name="date">
															<xsl:value-of select="./ref:RecordedDate"/>
														</xsl:with-param>
													</xsl:call-template>
												</td>
											</tr>
										</xsl:for-each>
									</table>
								</div>
							</td>
						</xsl:if>
						<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:PatientMeasurements/ref:BodyMeasurements">
							<td style="border:none;">
								<h3>Body Measurements</h3>
								<div class="sectionData">
									<table>
										<tr>
											<th>Height In Metres</th>
											<th>Weight In Kilograms</th>
											<th>BMI</th>
											<th>Date Recorded</th>
										</tr>
										<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:PatientMeasurements/ref:BodyMeasurements/ref:BodyMeasurement">
											<tr>
												<td>
													<xsl:call-template name="format_text">
														<xsl:with-param name="text">
															<xsl:value-of select="./ref:Height"/>
														</xsl:with-param>
													</xsl:call-template>
												</td>
												<td>
													<xsl:call-template name="format_text">
														<xsl:with-param name="text">
															<xsl:value-of select="./ref:Weight"/>
														</xsl:with-param>
													</xsl:call-template>
												</td>
												<td>
													<xsl:call-template name="format_text">
														<xsl:with-param name="text">
															<xsl:value-of select="./ref:BodyMassIndex"/>
														</xsl:with-param>
													</xsl:call-template>
												</td>
												<td>
													<xsl:call-template name="format_text">
														<xsl:with-param name="date">
															<xsl:value-of select="./ref:RecordedDate"/>
														</xsl:with-param>
													</xsl:call-template>
												</td>
											</tr>
										</xsl:for-each>
									</table>
								</div>
							</td>
						</xsl:if>
					</tr>
				</table>
			</div>
		</xsl:if>
		<!-- ################################################################################################ -->
		<!-- ############################# Additional Relevant Information ################################## -->
		<!-- ################################################################################################ -->
		<xsl:if test="//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[contains(text(), '(Systolic)')] or //ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[not(starts-with(text(), 'Date') or starts-with(text(), 'Patient Blood Pressure') or starts-with(text(), 'Visiting Patient?'))] or normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Peak Flow']]/gen:TestMeasurement/gen:MeasurementDescription)">
			<div class="sectionContainer additionalInfo clearfix">
				<h3>Additional Relevant Information</h3>
				<div class="yui-g sectionData">
					<table>
						<tr>
							<th>Description</th>
							<th>Value</th>
							<th>Date Taken</th>
						</tr>
						<xsl:for-each select="//ref:MessageDataRef/ref:PatientAdministrationRef/pbr:AdditionalInfo[not(starts-with(text(), 'Date') or starts-with(text(), 'Patient Blood Pressure') or starts-with(text(), 'Visiting Patient?') or starts-with(text(), 'Preferred Provider Site') or starts-with(text(), 'Reason for Preferred Site') or starts-with(text(), 'Framingham') or starts-with(text(), 'Middle Name'))]">
							<tr>
								<td>
									<xsl:value-of select="substring-before(text(), ':')"/>
								</td>
								<td>
									<xsl:value-of select="substring-after(text(), ':')"/>
								</td>
								<td>
									<xsl:call-template name="format_text">
										<xsl:with-param name="date">
											<xsl:for-each select="following-sibling::node()[starts-with(text(), 'Date') and position() = 1]">
												<xsl:value-of select="substring-after(text(), ':')"/>
											</xsl:for-each>
										</xsl:with-param>
									</xsl:call-template>
								</td>
							</tr>
						</xsl:for-each>
						<xsl:if test="normalize-space(//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Peak Flow']]/gen:TestMeasurement/gen:MeasurementDescription)">
							<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Peak Flow']]/gen:TestMeasurement/gen:MeasurementDescription">
								<tr>
									<td>Peak Flow</td>
									<td>
										<xsl:call-template name="format_text">
											<xsl:with-param name="text">
												<xsl:value-of select="."/>
											</xsl:with-param>
										</xsl:call-template>
									</td>
									<td>
										<xsl:call-template name="format_text">
											<xsl:with-param name="date">
												<xsl:value-of select="../../following-sibling::node()/gen:TestMeasurement/gen:MeasurementDescription"/>
											</xsl:with-param>
										</xsl:call-template>
									</td>
								</tr>
							</xsl:for-each>
						</xsl:if>
					</table>
				</div>
			</div>
		</xsl:if>
		<!-- ################################################################################################ -->
		<!-- ######################################### Family conditions #################################### -->
		<!-- ################################################################################################ -->
		<xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:FamilyHistory">
			<div class="sectionContainer familyConditions clearfix">
				<h3>Family History</h3>
				<div class="yui-g sectionData">
					<table>
						<tr>
							<th>Description</th>
							<th>Relation to Patient</th>
							<th>Date Recorded</th>
						</tr>
						<xsl:for-each select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:FamilyHistory">
							<tr>
								<td>
									<xsl:call-template name="format_text">
										<xsl:with-param name="text">
											<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
										</xsl:with-param>
									</xsl:call-template>
								</td>
								<td>
									<xsl:call-template name="format_text">
										<xsl:with-param name="text">
											<xsl:value-of select="gen:RelationToPatient"/>
										</xsl:with-param>
									</xsl:call-template>
								</td>
								<td>
									<xsl:call-template name="format_text">
										<xsl:with-param name="date">
											<xsl:value-of select="gen:FamilyCondition/gen:DateOfOnset"/>
										</xsl:with-param>
									</xsl:call-template>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</div>
			</div>
		</xsl:if>
		<!-- ################################################################################################ -->
		<!-- ######################################### Social circumstances ################################# -->
		<!-- ################################################################################################ 
        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Housing or //ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Employment or //ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:LifestyleRisk/gen:ReligiousObservance or //ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Religion or //ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:EthnicOrigin or //ref:MessageDataRef/ref:PatientDemographics/gen:MaritalStatus or //ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Disability']]/gen:TestMeasurement/gen:MeasurementDescription[text()='Yes'] or //ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Details of Disability']]/gen:TestMeasurement/gen:MeasurementDescription">
            <div class="sectionContainer socialCircumstances clearfix">
                <h3>Social Circumstances</h3>

                <div class="yui-g sectionData">
                    <dl>
                        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Housing">
                            <dt>Housing</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Housing"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>

                        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Employment">
                            <dt>Employment</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Employment"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>

                        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:LifestyleRisk/gen:ReligiousObservance">
                            <dt>Religious Observance</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:LifestyleRisk/gen:ReligiousObservance"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>

                        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Religion">
                            <dt>Religion</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:Religion"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>

                        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:EthnicOrigin">
                            <dt>Ethnic Origin</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances/gen:EthnicOrigin"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>

                        <xsl:if test="//ref:MessageDataRef/ref:PatientDemographics/gen:MaritalStatus">
                            <dt>Marital Status</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:PatientDemographics/gen:MaritalStatus"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>

                        <xsl:if test="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Disability']]/gen:TestMeasurement/gen:MeasurementDescription[text()='Yes'] or //ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Details of Disability']]/gen:TestMeasurement/gen:MeasurementDescription">
                            <dt>Disability</dt>
                            <dd>
                                <xsl:call-template name="format_text">
                                    <xsl:with-param name="default">Yes - Details Not Supplied</xsl:with-param>
                                    <xsl:with-param name="text">
                                        <xsl:value-of select="//ref:MessageDataRef/ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Details of Disability']]/gen:TestMeasurement/gen:MeasurementDescription"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </dd>
                        </xsl:if>
                    </dl>
                </div>
            </div>
        </xsl:if>
		-->
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ######################################### REUSABLE TEMPLATES ################################### -->
	<!-- ################################################################################################ -->
	<xsl:template match="gen:PatientAddress | gen:OrganisationAddress">
		<p class="address titleCase">
			<xsl:choose>
				<xsl:when test="gen:UnstructuredAddress">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:UnstructuredAddress"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="gen:StructuredAddress/gen:PropertyNumber"/>
					<xsl:for-each select="gen:StructuredAddress/gen:AddressLine">
						<xsl:value-of select="."/>
						<br/>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="gen:PostCode">
				<span class="upperCase">
					<xsl:value-of select="gen:PostCode"/>
				</span>
			</xsl:if>
		</p>
	</xsl:template>
	<xsl:template match="gen:PatientName | gen:HcpName">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredName">
				<xsl:value-of select="gen:UnstructuredName"/>
			</xsl:when>
			<xsl:when test="gen:StructuredName">
				<xsl:if test="gen:StructuredName/gen:Title">
					<xsl:value-of select="gen:StructuredName/gen:Title"/>
					&#160;
				</xsl:if>
				<span class="titleCase">
					<xsl:value-of select="gen:StructuredName/gen:GivenName"/>
					<xsl:for-each select="gen:StructuredName/gen:MiddleName">
						&#160;<xsl:value-of select="."/>
					</xsl:for-each>
				</span>
				&#160;
				<span class="upperCase">
					<xsl:value-of select="gen:StructuredName/gen:FamilyName"/>
				</span>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default_blank"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="gen:RegisteredGp | ref:ReferringGP">
		<dl class="gpDetails">
			<dt class="first">Name</dt>
			<dd class="first titleCase">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:HcpName/gen:UnstructuredName"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<dt>GMC Code</dt>
			<dd>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:HcpId[gen:IdScheme='GmcCode']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<dt>Practice Name</dt>
			<dd>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:EmployingOrganisation/gen:OrganisationName"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<dt>Practice Code</dt>
			<dd>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:EmployingOrganisation/gen:OrganisationId[gen:IdScheme='PracticeID']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<xsl:if test="name(.)='ref:ReferringGP'">
				<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Designation']]/gen:TestMeasurement/gen:MeasurementDescription)">
					<dt>Designation</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Designation']]/gen:TestMeasurement/gen:MeasurementDescription"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
				</xsl:if>
			</xsl:if>
			<dt>Practice Address</dt>
			<dd>
				<span class="titleCase">
					<xsl:apply-templates select="gen:EmployingOrganisation/gen:OrganisationAddress"/>
				</span>
			</dd>
			<xsl:if test="gen:EmployingOrganisation/gen:OrganisationTelecom">
				<xsl:apply-templates select="gen:EmployingOrganisation/gen:OrganisationTelecom" mode="all"/>
			</xsl:if>
		</dl>
	</xsl:template>
	<xsl:template match="ref:ReferringParty">
		<dl class="gpDetails">
			<dt class="first">Name</dt>
			<dd class="first titleCase">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="concat(ref:ReferringHcp/gen:HcpName/gen:StructuredName/gen:GivenName, ' ',ref:ReferringHcp/gen:HcpName/gen:StructuredName/gen:FamilyName)"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<dt>
				<xsl:value-of select="ref:ReferringHcp/gen:HcpId[position()=1]/gen:IdScheme"/>
			</dt>
			<dd>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringHcp/gen:HcpId[position()=1]/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<dt>Organisation Name</dt>
			<dd>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringOrg/gen:OrganisationName"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<dt>Location Code</dt>
			<dd>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringOrg/gen:OrganisationId[gen:IdScheme='LocationCode']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</dd>
			<xsl:if test="name(.)='ref:ReferringGP'">
				<xsl:if test="normalize-space(//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Designation']]/gen:TestMeasurement/gen:MeasurementDescription)">
					<dt>Designation</dt>
					<dd>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="//ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:Examinations[gen:TestPerformed/gen:TestName/gen:ClinicalCircumstanceDescription[text()='Designation']]/gen:TestMeasurement/gen:MeasurementDescription"/>
							</xsl:with-param>
						</xsl:call-template>
					</dd>
				</xsl:if>
			</xsl:if>
			<dt>Organisation Address</dt>
			<dd>
				<span class="titleCase">
					<xsl:apply-templates select="ref:ReferringOrg/gen:OrganisationAddress"/>
				</span>
			</dd>
			<xsl:if test="ref:ReferringOrg/gen:OrganisationTelecom">
				<xsl:apply-templates select="ref:ReferringOrg/gen:OrganisationTelecom" mode="all"/>
			</xsl:if>
		</dl>
	</xsl:template>
	<xsl:template match="gen:PatientTelecom | gen:HcpTelecom | gen:OrganisationTelecom" mode="all">
		<xsl:if test="gen:UnstructuredTelecom[not('')] or gen:StructuredTelecom[not('')]">
			<dt>
				<xsl:choose>
					<xsl:when test="gen:TelecomType!='Voice'">
						<xsl:value-of select="gen:TelecomType"/>
					</xsl:when>
					<xsl:when test="gen:TelecomType='Voice'">Telephone</xsl:when>
				</xsl:choose>
			</dt>
			<dd>
				<xsl:apply-templates select="." mode="single"/>
			</dd>
		</xsl:if>
	</xsl:template>
	<xsl:template match="gen:PatientTelecom | gen:HcpTelecom | gen:OrganisationTelecom" mode="single">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredTelecom[not('')]">
				<xsl:value-of select="gen:UnstructuredTelecom"/>
			</xsl:when>
			<xsl:when test="gen:StructuredTelecom[not('')]">
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomCountry"/>
				(<xsl:value-of select="gen:StructuredTelecom/gen:TelecomArea"/>)
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomNo"/>
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomExt"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default_blank"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="ref:CurrentMedication | gen:MedicationOnRecord">
		<tr>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugCodeValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugIdentifier"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:Formulation"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:choose>
							<xsl:when test="gen:UnstructuredDosage">
								<xsl:value-of select="gen:UnstructuredDosage"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="gen:StructuredDosage/gen:DoseDescription"/>
								<xsl:if test="gen:StructuredDosage/gen:TimeOfAdministration">
									at
									<xsl:value-of select="gen:StructuredDosage/gen:TimeOfAdministration"/>
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:StructuredDosage/gen:Frequency"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:StructuredDosage/gen:MedicationStartDate"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<xsl:if test="name(.)!='ref:CurrentMedication'">
				<td>
					<xsl:choose>
						<xsl:when test="normalize-space(gen:StructuredDosage/gen:DrugDuration/gen:DrugDays/gen:TimeValue)">
							<xsl:value-of select="gen:StructuredDosage/gen:DrugDuration/gen:DrugDays/gen:TimeValue"/>
							&#160;
							<xsl:value-of select="gen:StructuredDosage/gen:DrugDuration/gen:DrugDays/gen:TimeUnit"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$default_blank"/>
						</xsl:otherwise>
					</xsl:choose>
				</td>
			</xsl:if>
		</tr>
	</xsl:template>
	<!-- ################################################################################################ -->
	<!-- ######################################### FUNCTIONS ############################################ -->
	<!-- ################################################################################################ -->
	<xsl:template name="format_text">
		<xsl:param name="text"/>
		<xsl:param name="date"/>
		<xsl:param name="datetime"/>
		<xsl:param name="default" select="$default_blank"/>
		<xsl:choose>
			<xsl:when test="normalize-space($date)">
				<xsl:value-of select="user:UnambiguousDate(string($date), string($default))"/>
			</xsl:when>
			<xsl:when test="normalize-space($datetime)">
				<xsl:value-of select="user:UnambiguousDateShortTime(string($datetime), string($default))"/>
			</xsl:when>
			<xsl:when test="normalize-space($text)">
				<xsl:value-of disable-output-escaping="yes" select="user:FormatLineBreaks(string($text))"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
