<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:cl="http://www.show.scot.nhs.uk/isd/ClinicalLetter" xmlns:gen="http://www.show.scot.nhs.uk/isd/General" xmlns:xsi="http://www.w3.org/2000/10/XMLSchema-instance" xmlns:h="http://www.w3.org/1999/xhtml" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:user="mailto:scisupport@gpass.csa.scot.nhs.uk">
    <xsl:output method="text" encoding="utf-8" indent="no"/>
    
    <!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
    <msxsl:script language="JScript" implements-prefix="user"><![CDATA[

    function get_month(p_Month)
   {
       var strMonth;

       switch (p_Month) {
       case "01" :
           strMonth = "Jan";
           break;
       case "02" :
           strMonth = "Feb";
           break;
       case "03" :
           strMonth = "Mar";
           break;
       case "04" :
           strMonth = "Apr";
           break;
       case "05" :
          strMonth = "May";
          break;
      case "06" :
          strMonth = "Jun";
          break;
      case "07" :
          strMonth = "Jul";
          break;
      case "08" :
          strMonth = "Aug";
          break;
      case "09" :
          strMonth = "Sep";
          break;
      case "10" :
          strMonth = "Oct";
          break;
      case "11" :
          strMonth = "Nov";
          break;
      case "12" :
          strMonth = "Dec";
          break; 
      default :
          strMonth = "   ";
   } 

  return(strMonth);

}
		function isDate(value)
   {
       return(!isNaN(new Date(value)));  
   }
    
    function UnambiguousDate(p_date)
   {
   
     var dteDate;
     var strDay, strMonth, strYear, strDate;

     // Garuanteed formats
     strDate = new String(p_date);
     strYear = strDate.substring(0,4);  
     strMonth = strDate.substring(5,7);
     strDay = strDate.substring(8,10);
  
     if (isDate(new Date(strYear,strMonth,strDay)))
     {
         return(strDay + "-" + get_month(strMonth) + "-" + strYear);
     }
}

                
    ]]></msxsl:script>
    <!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
    
    <xsl:template match="/cl:ClinicalLetter">
        <xsl:apply-templates select="./cl:MessageData/cl:PatientDemographics/gen:PatientName/gen:StructuredName"/>, <xsl:apply-templates select="./cl:DocumentData/gen:PatientId[gen:IdScheme='CHI']/gen:IdValue"/>
    </xsl:template>
    
    <!--
    Template will output "Patient: Unknown" if no FamilyName specified;
    otherwise "FamilyName" if no GivenName is specified; or "FamilyName, GivenName" if GivenName is specified
    -->
    <xsl:template match="gen:StructuredName">
        <xsl:choose>
            <xsl:when test="string-length(gen:FamilyName) > 0">
                <xsl:value-of select="gen:FamilyName"/>
                <xsl:if test="string-length(gen:GivenName) > 0">, <xsl:value-of select="gen:GivenName"/>
                </xsl:if>
            </xsl:when>
            <xsl:otherwise>
                Patient: Unknown
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <!--
    Template will output "CHI: {IdValue}" if a CHI is specified; otherwise "CHI: Unknown"
    -->
    <xsl:template match="gen:IdValue">
        <xsl:choose>
            <xsl:when test="string-length(.) > 0">
                CHI: <xsl:value-of select="."/>
            </xsl:when>
            <xsl:otherwise>
                CHI: Unknown
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
</xsl:stylesheet>