<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" encoding="UTF-8" indent="yes"/>
	<xsl:template match="*">
		<xsl:element name="prtobjcts">
			<xsl:apply-templates select="//question"/>
			<xsl:element name="hdnflds"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="question">
		<xsl:variable name="lcletters">abcdefghijklmnopqrstuvwxyz</xsl:variable>
		<xsl:variable name="ucletters">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable>
		<xsl:variable name="toconvert">
			<xsl:value-of select="@id"/>
		</xsl:variable>
		<xsl:variable name="lowercaseID">
			<xsl:value-of select="translate($toconvert,$ucletters,$lcletters)"/>
		</xsl:variable>
		<xsl:element name="prtobjct">
			<xsl:attribute name="id"><xsl:value-of select="$lowercaseID"/></xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
            <xsl:if test ="@type='check'">
                <xsl:if test ="@checkedvalue != ''">
                    <xsl:attribute name="checkedvalue">
                        <xsl:value-of select="@checkedvalue"/>
                    </xsl:attribute>
                </xsl:if>
            </xsl:if>
			<xsl:if test="@type != 'dynaTable' and @type!='table'">
				<xsl:attribute name="objecttype">field</xsl:attribute>
			</xsl:if>
			<xsl:if test="@type='dynaTable' or @type='table'">
				<xsl:attribute name="objecttype">table</xsl:attribute>
			</xsl:if>
			<xsl:if test="@type='giDynaTable'">
				<xsl:attribute name="objecttype">generictable</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="dynamic"><xsl:value-of select="(substring($lowercaseID,1,6) = 'admin_') or (substring($lowercaseID,1,12) = 'examination_') or (substring($lowercaseID,1,14) = 'investigation_') or (substring($lowercaseID,1,12)='verification') or (substring($lowercaseID,1,12)='structadmin_') or (substring($lowercaseID,1,8)='fpadmin_') or (substring($lowercaseID,1,13)='protresponse_')"/></xsl:attribute>
			<xsl:choose>
				<xsl:when test="substring($lowercaseID,1,13) = 'verification_'">
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,12)"/>
					</xsl:variable>
					<xsl:attribute name="group">verification</xsl:attribute>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
				</xsl:when>
				<xsl:when test="substring($lowercaseID,1,12) = 'structadmin_'">
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,11)"/>
					</xsl:variable>
					<xsl:attribute name="group">structadmin</xsl:attribute>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
                    <xsl:if test ="@letterlabel != '' and @type!='giDynaTable'">
                        <xsl:attribute name="letterlabel">
                            <xsl:value-of select="@letterlabel"/>
                        </xsl:attribute>
                    </xsl:if>
				</xsl:when> 
				<xsl:when test="substring($lowercaseID,1,8) = 'fpadmin_'">
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,7)"/>
					</xsl:variable>
					<xsl:attribute name="group">fpadmin</xsl:attribute>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
                    <xsl:if test ="@letterlabel != '' and @type!='giDynaTable'">
                        <xsl:attribute name="letterlabel">
                            <xsl:value-of select="@letterlabel"/>
                        </xsl:attribute>
                    </xsl:if>
				</xsl:when> 
				<xsl:when test="substring($lowercaseID,1,13) = 'protresponse_'">
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,12)"/>
					</xsl:variable>
					<xsl:attribute name="group">protresponse</xsl:attribute>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
                    <xsl:if test ="@letterlabel != '' and @type!='giDynaTable'">
                        <xsl:attribute name="letterlabel">
                            <xsl:value-of select="@letterlabel"/>
                        </xsl:attribute>
                    </xsl:if>
				</xsl:when> 
				<xsl:when test="substring($lowercaseID,1,6) = 'admin_'">
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,5)"/>
					</xsl:variable>
					<xsl:attribute name="group">admin</xsl:attribute>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
				</xsl:when>
				<xsl:when test="substring($lowercaseID,1,12) = 'examination_'">
					<xsl:attribute name="group">examination</xsl:attribute>
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,11)"/>
					</xsl:variable>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
				</xsl:when>
				<xsl:when test="substring($lowercaseID, 1,14) = 'investigation_'">
					<xsl:variable name="groupid">
						<xsl:value-of select="substring($lowercaseID,1,13)"/>
					</xsl:variable>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$groupid]/attribute::buildorder"/></xsl:attribute>
					<xsl:attribute name="group">investigation</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="buildorder"><xsl:value-of select="/objectlist/message/messageitem[@id=$lowercaseID]/attribute::buildorder"/></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="@type='dynaTable' or @type='table'">
				<xsl:attribute name="objecttype">table</xsl:attribute>
				<xsl:attribute name="tablelabel"><xsl:value-of select="@text"/></xsl:attribute>
				<xsl:apply-templates select="column"/>
				<xsl:if test="@type='table'">
					<xsl:apply-templates select="row"/>
				</xsl:if>
			</xsl:if>
			<xsl:if test="@type='giDynaTable'">
				<xsl:attribute name="objecttype">generictable</xsl:attribute>
                <xsl:attribute name="tablelabel"><xsl:value-of select="@text"/></xsl:attribute>
                <xsl:if test ="@letterlabel != ''">
                    <xsl:attribute name="tablelabel">
                        <xsl:value-of select="@letterlabel"/>
                    </xsl:attribute>
                </xsl:if>
				<xsl:apply-templates select="column"/>
				<xsl:if test="@type='table'">
					<xsl:apply-templates select="row"/>
				</xsl:if>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template match="column">
		<xsl:variable name="lcletters">abcdefghijklmnopqrstuvwxyz</xsl:variable>
		<xsl:variable name="ucletters">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable>
		<xsl:variable name="toconvert">
			<xsl:value-of select="@id"/>
		</xsl:variable>
		<xsl:element name="column">
			<xsl:attribute name="id"><xsl:value-of select="translate($toconvert,$ucletters,$lcletters)"/></xsl:attribute>
			<xsl:attribute name="columnlabel"><xsl:value-of select="@text"/></xsl:attribute>
            <xsl:if test ="@letterlabel != ''">
                <xsl:attribute name="columnlabel">
                    <xsl:value-of select="@letterlabel"/>
                </xsl:attribute>
            </xsl:if>
            <xsl:if test="@type!=''">
				<xsl:attribute name="columntype"><xsl:value-of select="@type"/></xsl:attribute>
			</xsl:if>
		</xsl:element>
		<!-- CUSTOM: if this is a startdate column, check if there is a enddate column, and if so, create a durationDays column-->
		<xsl:variable name="column1">startdate</xsl:variable>
		<xsl:variable name="column2">enddate</xsl:variable>
		<xsl:variable name="column3">completiondate</xsl:variable>
		<xsl:variable name="lowercaseid">
			<xsl:value-of select="translate($toconvert,$ucletters,$lcletters)"/>
		</xsl:variable>
		<xsl:if test="$lowercaseid = $column1 and count(../column[translate(@id,$ucletters,$lcletters)=$column2]) = 1">
			<xsl:element name="column">
				<xsl:attribute name="id">duration</xsl:attribute>
				<xsl:attribute name="timedimabbr">D</xsl:attribute>
				<xsl:attribute name="datatype">date</xsl:attribute>
				<xsl:attribute name="calculate">true</xsl:attribute>
				<xsl:attribute name="firstcolumn"><xsl:value-of select="$column1"/></xsl:attribute>
				<xsl:attribute name="secondcolumn"><xsl:value-of select="$column2"/></xsl:attribute>
			</xsl:element>
			<xsl:element name="column">
				<xsl:attribute name="id">timedimension</xsl:attribute>
				<xsl:attribute name="autovalue">Days</xsl:attribute>
			</xsl:element>
		</xsl:if>
		<xsl:if test="$lowercaseid = $column1 and count(../column[translate(@id,$ucletters,$lcletters)=$column3]) = 1">
			<xsl:element name="column">
				<xsl:attribute name="id">trigger</xsl:attribute>
				<xsl:attribute name="autovalue">Completion Date</xsl:attribute>
			</xsl:element>
		</xsl:if>
	</xsl:template>
	<xsl:template match="row">
		<xsl:element name="row">
			<xsl:attribute name="id"><xsl:value-of select="position()"/></xsl:attribute>
			<xsl:attribute name="rowlabel"><xsl:value-of select="@text"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
